﻿using AIOUSBNet;  // namespace exposes AIOUSB Class interface
using Sharp7;
using System;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace Sample1
{
    public partial class ConsoleConnectTestForm3 : Form
    {
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool ShowWindowAsync(IntPtr hWnd, int nCmdShow);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool SetWindowLongPtrA(IntPtr hWnd, int nIndex, IntPtr dwNewLong);

        [DllImport("user32.dll")]
        private static extern IntPtr SetActiveWindow(IntPtr hWnd);

        [DllImport("user32.dll", EntryPoint = "SetWindowPos")]
        public static extern IntPtr SetWindowPos(IntPtr hWnd, int hWndInsertAfter, int x, int Y, int cx, int cy, int wFlags);

        private Process ProcessProperties = new Process();
        public delegate void frm3Focus();
        public frm3Focus myDelegate;
        private S7Client Client = new S7Client();
        private Socket sock;
        public object TCPSocket { get; private set; }
        private TcpClient tcpclnt = new TcpClient();

        //Declare and Initialize the IP Adress
        private IPAddress ipAd = IPAddress.Parse("10.11.51.222");

        private bool bVSpyDone;

        private object bParsingComplete;

        //g System;

        public struct ComponentResult
        {
            public string SerialNumber; // Component Serial Number
            public int TestResult; // Result code 0:Unknown, 1:Good, 2:Scrap
            public double LeakDetected; // Leak value [cc/min]
            public DateTime TestDateTime; // Test Timestamp
        }

        public ConsoleConnectTestForm3()
        {
            InitializeComponent();
        }

        //**************************************************************
        //**********  Form 3 Load **************************************
        //*************************************************************

        private void Form3_Load(object sender, EventArgs e)
        {
            myDelegate = new ConsoleConnectTestForm3.frm3Focus(frm3FocusMethod);

            //*************************************************************
            // ***** PREMIUM MANIFEST FOR RED RABBIT TEST NOT FROM THE PLC
            //****** MUST REMOVE REMARKS FOR PRODUCTION
            //************************************************************

            // ONE SHOT
            //         if (textBoxRESULTS.Text.Contains("Finished Read of PLC DB Manifest with Sharp7"))
            //         {
            // DO NOTHING

            //         }
            //        else
            //         {
            // *********************************************
            // *********** Read PLC DB Manifest with Sharp7
            // *********************************************

            //              int Rack = 0;
            //              int Slot = 0;
            //              int Good = 0;

            //              Client.ConnectTo("10.11.51.50", Rack, Slot);
            //              Client.Connect();

            //SetConnectionParams

            //              ComponentResult Result = new ComponentResult();
            //              byte[] Buffer = new byte[256];

            //              Client.DBRead(61, 0, 256, Buffer);
            //              string msg = System.Text.Encoding.ASCII.GetString(Buffer);

            //              textBoxRESULTS.Text += "\n";
            //              for (int iii = 0; iii < 256; ++iii)
            //              {
            //                  textBoxRESULTS.Text += Buffer[iii].ToString("x2") + ",";
            //             }
            //              textBoxRESULTS.Text += "\n";

            //              textBoxRESULTS.Text = textBoxRESULTS.Text + "Finished Read of PLC DB Manifest with Sharp7\n\r\n\r";

            // Extracts the fields and inserts them into the struct
            //  Result.SerialNumber = S7.GetCharsAt(Buffer, 0, 12);
            //  Result.TestResult = S7.GetIntAt(Buffer, 12);
            //  Result.LeakDetected = S7.GetRealAt(Buffer, 14);
            //  Result.TestDateTime = S7.GetDateTimeAt(Buffer, 18);

            //          }

            //*********************************************
            // ***** PREMIUM MANIFEST FOR RED RABBIT TEST
            //****** MUST REMARK OUT FOR PRODUCTION
            //********************************************

            // CONSOLE MANIFEST - Highline
            //textBoxRESULTS.Text = ""; // Clear Screen
            textBoxRESULTS.Text += "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,13529875FW85,4301,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,13592452FW74,3501,84952174FW83,4201,84786104FW68,3101,84960563M33V,3301,13537143M08L,2901,";

            // *******************************************************
            // ********* CONSOLE TEST MOD codes for USB test *********
            // *******************************************************

            /* if manifest has not arrived then show that on the form
             *
             *
             * */
            gv.CUPHOLDER_USB_SCAN = gv.CUPHOLDER_USB_TEST = (textBoxRESULTS.Text.Contains(",4301,")) ? "YELO" : "GRAY";// Search Manifest for Modcode (Cupholder USB)
            gv.BODY_USB_SCAN = gv.BODY_USB_TEST = (textBoxRESULTS.Text.Contains(",3002,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (Body USB)
            gv.ENDCAP_USB_SCAN = gv.ENDCAP_USB_TEST = (textBoxRESULTS.Text.Contains(",1502,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (Endcap USB)

            // *******************************************************
            // ********* CONSOLE TEST MOD codes **********************
            // *******************************************************
            gv.EOCM = (textBoxRESULTS.Text.Contains(",3301,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (EOCM)
            gv.WCM = (textBoxRESULTS.Text.Contains(",2901,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (WCM - WIRELESS CHARGE MODULE)
            gv.SEAT = (textBoxRESULTS.Text.Contains(",1101,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (HEATED SEAT SW.)
            gv.PEPS = (textBoxRESULTS.Text.Contains(",1302,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (PEPS ANTENNA)
            gv.SIB = (textBoxRESULTS.Text.Contains(",2701,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (SIB - SHIFT INTERFACE BOARD)
            gv.TBS = (textBoxRESULTS.Text.Contains(",4201,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (TRAILER BRAKE SWITCH)
            gv.LAMP = (textBoxRESULTS.Text.Contains(",402,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (MAIN CONSOLE LAMP)
            gv.IMOB = (textBoxRESULTS.Text.Contains(",3501,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (IMMOBILIZER ANTENNA)
            gv.HVPO = (textBoxRESULTS.Text.Contains(",3101,")
                    || textBoxRESULTS.Text.Contains(",3102,")) ? "YELO" : "GRAY"; // Search Manifest for Modcode (HIGH VOLTAGE PO 3101)

            OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
            OperatorInstructions.Text += "FIRST CONNECT USB\n\r\n\r\n\r";
            OperatorInstructions.Text += "SECOND CONNECT 55-WAY\n\r\n\r";

            InitializePartNumberTextBoxes();

            if (gv.diDIO == AIOUSB.diNone)
            {
                // Handle no IIRO / IDIO device found
            }
            else
            {
                // Initialize all Outputs to the OFF State
                _ = AIOUSB.DIO_Write1(gv.diDIO, 6, 1);  // Deactivate TEST FAIL (Interlock)
                _ = AIOUSB.DIO_Write1(gv.diDIO, 7, 1);  // Deactivate TEST PASS (Interlock)
                _ = AIOUSB.DIO_Write1(gv.diDIO, 8, 1);  // Deactivate END OF CYCLE (Interlock)
                _ = AIOUSB.DIO_Write1(gv.diDIO, 9, 1);  // Turn OFF SOL #1   CONSOLE 55-way LATCH / HEADLINER LATCH BH#1
                _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 1); // Turn OFF SOL #2   CONSOLE 55-way DRAW DOWN / HEADLINER LATCH BH#2
                _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1
                _ = AIOUSB.DIO_Write1(gv.diDIO, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2
                _ = AIOUSB.DIO_Write1(gv.diDIO, 13, 1); // TURN OFF SOL #5   HEADLINER AIR EJECT BH #3
                _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 1); // CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
            }

            //***********************************************************************************************************
            //************* iNITIALIZE WHICH TEST TO RUN BASED ON mod CODE OR MANUAL SELECTIONS GLOBAL VARIABLES = "YELO"
            //************************************************************************************************************
            button_LIN_Heated_Seat_Switch.BackColor = gv.SEAT.Contains("YELO") ? Color.Yellow : Color.LightGray;
            button_LIN_TBS.BackColor = gv.TBS.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonWCM.BackColor = gv.WCM.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonSIB.BackColor = gv.SIB.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonEOCM.BackColor = gv.EOCM.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonRFIDendcapUSB.BackColor = gv.ENDCAP_USB_SCAN.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonTESTendcapUSB.BackColor = gv.ENDCAP_USB_TEST.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonRFIDbodyUSB.BackColor = gv.BODY_USB_SCAN.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonTESTbodyUSB.BackColor = gv.BODY_USB_TEST.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonRFIDcupHolderUSB.BackColor = gv.CUPHOLDER_USB_SCAN.Contains("YELO") ? Color.Yellow : Color.LightGray;
            buttonTESTcupHolderUSB.BackColor = gv.CUPHOLDER_USB_TEST.Contains("YELO") ? Color.Yellow : Color.LightGray;

            ReadDigitalInputs(out _, out _);
            timerForm3_Connect55_way.Start();
        }

        private void InitializePartNumberTextBoxes()
        {
            textBoxfrm3VIN.Text = gv.VIN;

            // textBoxRESULTS.Text = textBoxRESULTS.Text + "Initalize Part Number Text Boxes\n\r\n\r";

            textBoxEOCM_BaseModelPartNumber8.Text = "";
            textBoxEOCM_EndModelPartNumber8.Text = "";
            textBoxEOCM_BootSWID8.Text = "";
            textBoxEOCM_AppSWID10.Text = "";
            textBoxEOCM_AppDataID10.Text = "";

            textBoxSIB_BaseModelPartNumber8.Text = "";
            textBoxSIB_EndModelPartNumber8.Text = "";
            textBoxSIB_BootSWID8.Text = "";
            textBoxSIB_AppSWID10.Text = "";
            textBoxSIB_AppDataID10.Text = "";

            textBoxWCM_BaseModelPartNumber8.Text = "";
            textBoxWCM_EndModelPartNumber8.Text = "";
            textBoxWCM_BootSWID8.Text = "";
            textBoxWCM_AppSWID10.Text = "";
            textBoxWCM_AppDataID10.Text = "";

            TextBox_Time_of_PN_Read.Text = "";
            TextBox_Date_of_PN_Read.Text = "";
        }

        // ******************************************************************************************************************************************
        // *********** Start of 500ms Tick Tock Loop ************************************************************************************************
        // ******************************************************************************************************************************************
        private void timerForm3_Connect55_way_Tick(object sender, EventArgs e)
        {
            textBoxfrm3VIN.Text = gv.VIN;

            if (OperatorInstructions.Text.Contains("SECOND CONNECT 55-WAY"))
                RefreshInstructionText();

            ReadDigitalInputs(out bool bConsole_PIP_55Way_Detected, out bool b5VUSBDetected);
            HandleManualRelease(bConsole_PIP_55Way_Detected);

            //debug fake USB-IIRO-16
            if (bConsole_PIP_55Way_Detected) // Console_PIP_55Way has been detected
            {
                // ONE SHOT
                if (!textBoxRESULTS.Text.Contains("55-way Connected"))
                    StartTest();

                if (true)
                {
                    bVSpyDone = vSpyGatherPartNumbers_StateMachine(); // state machine, runs every tick to perform next step in process
                }

                if (OperatorInstructions.Text.Contains("138")) // MASTER RFID CARD #69 WAS DETECTED,  GOTO CSN # KEYPAD SCREEN
                    gv.CSNEntryForm.Show();

                TestUSB_Cupholder(b5VUSBDetected);

                TestUSB_Body(b5VUSBDetected);

                TestUSB_Endcap(b5VUSBDetected);

                //if (global_variables.WCM.Contains("PASS"))
                //if (textBoxRESULTS.Text.Contains(",3101,") || textBoxRESULTS.Text.Contains(",3102,"))
                if (buttonTESTendcapUSB.BackColor != Color.Yellow)
                {
                    if (buttonTESTbodyUSB.BackColor != Color.Yellow)
                    {
                        if (buttonTESTcupHolderUSB.BackColor != Color.Yellow)
                        {
                            OperatorInstructions.Text = ""; // CLEAR SCREEN
                            OperatorInstructions.Text += "<<< TESTER >>>\n\r\n\r\n\r";
                            OperatorInstructions.Text += "READING MODULE\n\r\n\r\n\r";
                            OperatorInstructions.Text += "PART NUMBERS\n\r\n\r\n\r";

                            textBoxRESULTS.Text += "<<<<< All Required USB's were tested >>>>\n\r\n\r";
                            if (bVSpyDone)
                            {
                                OperatorInstructions.Text = ""; // CLEAR SCREEN
                                OperatorInstructions.Text += "<<< TESTER >>>\n\r\n\r\n\r";
                                OperatorInstructions.Text += "Generating Results\n\r\n\r\n\r";

                                bParsingComplete = ParseVSpyResultsFiles();

                                OperatorInstructions.Text = ""; // CLEAR SCREEN
                                OperatorInstructions.Text += "<<< TESTER >>>\n\r\n\r\n\r";
                                OperatorInstructions.Text += "Test Complete\n\r\n\r\n\r";
                            }
                        }
                    }
                }
            }

            if (textBoxRESULTS.Text.Contains("Parsed Multiple.txt files\n\r"))
            {
                timerForm3_Connect55_way.Stop();
                gv.DiagnosticForm.Show();
            }
        } // Timer

        private static void ReadDigitalInputs(out bool bConsole1Detected, out bool b5VUSBDetected)
        {
            byte[] data = new byte[] { 0, 0, 0, 0 };
            _ = AIOUSB.DIO_ReadAll(gv.diDIO, data);
            bConsole1Detected = ((data[2] & 0x02) == 0x02); // Console 55-way detected
            //bConsole1Detected = true; //DEBUG --J2H
            bool bHeadliner1Detected = ((data[2] & 0x02) == 0x02); // Headliner 55-way PIP Switch
            bool bHeadliner2Detected = ((data[2] & 0x04) == 0x04); // Headliner 16-way X1 PIP Switch
            b5VUSBDetected = ((data[2] & 0x40) == 0x40);
            //b5VUSBDetected = true; //DEBUG --J2H

            if (bHeadliner1Detected) // Headliner_PIP_59Way has been detected
            {
                _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 0); // Energize Sol #3   HEADLINER DRAW DOWN BH #1 59-way
            }

            if (bHeadliner2Detected) // Headliner_PIP_55Way has been detected
            {
                _ = AIOUSB.DIO_Write1(gv.diDIO, 12, 0); // Energize Sol #4   HEADLINER DRAW DOWN BH #2 55-way
            }
        }

        private void HandleManualRelease(bool bConsole1Detected)
        {
            // *****************************************************
            // ***** TEST FOR MANUAL RELEASE BUTTON PRESSED ON 55 WAY
            // *****************************************************
            if (bConsole1Detected) // Console_PIP_55-way
            {
                // DO NOTHING
            }
            else  // MANUAL RELEASE PRESSED ON 59-WAY ?
            {
                if (textBoxRESULTS.Text.Contains("55-way Connected"))
                {
                    // RELEASE BOTH 55-WAY AND 16/16-WAY UNLATCH AND BLOW OFF SINCE IT HAS NO PUSH BUTTON
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1 59-WAY
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 9, 1);  // Turn OFF SOL #1   HEADLINER LATCH BH #1 59-WAY
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 13, 0); // TURN ON SOL #5   HEADLINER AIR EJECT BH #3 16/16-WAY

                    if (gv.VSpy3ProcessHandle != null)
                        gv.VSpy3ProcessHandle.Kill();
                    gv.VSpy3ProcessHandle = null;

                    Close();
                }
            }
        } // HandleManualRelease

        //*************************************************************************************
        //***********  Prompt Operator to SCAN RFID Tag and test the 5VUSB ports
        //*************************************************************************************
        private void TestUSB_Endcap(bool b5vUSBConnected)
        {
            if (OperatorInstructions.Text.Contains("7"))
            {
                buttonRFIDendcapUSB.BackColor = Color.Aquamarine;
                if (gv.ENDCAP_USB_SCAN.Contains("YELO"))  // Manual or MOD CODE selected
                {
                    // ENDCAP RFID CARD SCAN DETECTED
                    //EndcapUSBrfidRESULT = 1; // Scanned
                    textBoxRESULTS.Text += "Endcap USB Card Scanned\n\r\n\r";
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 0); // "ON" CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
                    OperatorInstructions.Text += "TEST ENDCAP USB\n\r\n\r\n\r";
                    gv.ENDCAP_USB_SCAN = "PASS";
                }
                else
                {
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
                    OperatorInstructions.Text += "ONLY SCAN NEXT YELLOW\n\r\n\r\n\r";
                    OperatorInstructions.Text += "USB TEST CARD\n\r\n\r\n\r";
                }
            }

            if (gv.ENDCAP_USB_SCAN == "PASS")
                if (b5vUSBConnected)
                {
                    buttonTESTendcapUSB.BackColor = Color.Aquamarine;
                    gv.ENDCAP_USB_TEST = "PASS";
                    button1.BackColor = Color.Aquamarine; // Connect USB Button Color on touch screen
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 1); // "OFF" CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                }
        } // TestUSB_Endcap

        //*************************************************************************************
        //***********  Prompt Operator to SCAN RFID Tag and test the 5VUSB ports
        //*************************************************************************************
        private void TestUSB_Body(bool b5vUSBConnected)
        {
            if (OperatorInstructions.Text.Contains("4"))
            {
                buttonRFIDbodyUSB.BackColor = Color.Aquamarine;
                if (gv.BODY_USB_SCAN.Contains("YELO"))  // Manual or MOD CODE selected
                {
                    // BODY RFID CARD SCAN DETECTED
                    //BodyUSBrfidRESULT = 1; // Scanned
                    textBoxRESULTS.Text += "Body USB Card Scanned\n\r\n\r";
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 0); // "ON" CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
                    OperatorInstructions.Text += "TEST BODY USB\n\r\n\r\n\r";
                    gv.BODY_USB_SCAN = "PASS";
                }
                else
                {
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
                    OperatorInstructions.Text += "ONLY SCAN NEXT YELLOW\n\r\n\r\n\r";
                    OperatorInstructions.Text += "USB TEST CARD\n\r\n\r\n\r";
                }
            }

            if (gv.BODY_USB_SCAN == "PASS")
                if (b5vUSBConnected)
                {
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 1); // "OFF" CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                    buttonTESTbodyUSB.BackColor = Color.Aquamarine;
                    gv.BODY_USB_TEST = "PASS";
                    button1.BackColor = Color.Aquamarine; // Connect USB Button Color on touch screen
                }
        } // TestUSB_Body

        //*************************************************************************************
        //***********  Prompt Operator to SCAN RFID Tag and test the 5VUSB ports
        //*************************************************************************************
        private void TestUSB_Cupholder(bool b5vUSBConnected)
        {
            if (OperatorInstructions.Text.Contains("2"))
            {
                buttonRFIDcupHolderUSB.BackColor = Color.Aquamarine;
                if (gv.CUPHOLDER_USB_SCAN.Contains("YELO"))  // Manual or MOD CODE selected
                {
                    // CUPHOLDER RFID CARD SCAN DETECTED
                    textBoxRESULTS.Text += "Cupholder USB Card Scanned\n\r\n\r";
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 0); // "ON" CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
                    OperatorInstructions.Text += "TEST CUPHOLDER USB\n\r\n\r\n\r";
                    gv.CUPHOLDER_USB_SCAN = "PASS";
                }
                else
                {
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
                    OperatorInstructions.Text += "ONLY SCAN NEXT YELLOW\n\r\n\r\n\r";
                    OperatorInstructions.Text += "USB TEST CARD\n\r\n\r\n\r";
                }
            }

            if (gv.CUPHOLDER_USB_SCAN == "PASS")
                if (b5vUSBConnected)
                {
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 1); // "OFF" CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                    buttonTESTcupHolderUSB.BackColor = Color.Aquamarine;
                    gv.CUPHOLDER_USB_TEST = "PASS";
                    button1.BackColor = Color.Aquamarine; // Connect USB Button Color on touch screen
                }
        } // TestUSB_Cupholder

        private void StartTest()
        {
            // **************************************************************************************************************************
            // ****************** Start the Console Test Automatic Sequence *************************************************************
            // **************************************************************************************************************************
            textBoxRESULTS.Text += "<<< STEP #1 - Start the Console Test Automatic Sequence >>>>\n\r\n\r";
            //***************************************************************************************************************************
            //***************************************************************************************************************************

            _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 0); // Energize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
            _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 0); // Energize Sol #2   CONSOLE 55-way DRAW DOWN
            labelDrawDownCON55.BackColor = Color.Aquamarine;
            labelPIPswitchCON55A.BackColor = Color.Aquamarine;
            labelPIPswitchCON55B.BackColor = Color.Aquamarine;

            // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
            _ = AIOUSB.DIO_Write1(gv.diDIO, 9, 0);  // Energize SOL #1   CONSOLE 55-way LATCH
            labelLatchCON55.BackColor = Color.Aquamarine;
            buttonConnect55Way.BackColor = Color.Aquamarine; // Connect 55-way Button Color on touch screen
            textBoxRESULTS.Text += "55-way PIP detected\n\r\n\r";
            textBoxRESULTS.Text += "55-way Drawdown Solenoid Energized\n\r\n\r";
            textBoxRESULTS.Text += "55-way Latch Solenoid Energized\n\r\n\r";
            textBoxRESULTS.Text += "55-way Connected\n\r\n\r";

            OperatorInstructions.Text = ""; // CLEAR SCREEN
            OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
            OperatorInstructions.Text += "SCAN ANY YELLOW\n\r\n\r\n\r";
            OperatorInstructions.Text += "USB TEST CARD\n\r\n\r\n\r";
        } // StartTest

        private void RefreshInstructionText()
        {
            // Refresh Operator Startup Screen Prompt
            OperatorInstructions.Text = ""; // Clear Screen
            OperatorInstructions.Text += "<<< OPERATOR >>>\n\r\n\r\n\r";
            OperatorInstructions.Text += "FIRST CONNECT USB\n\r\n\r\n\r";
            OperatorInstructions.Text += "SECOND CONNECT 55-WAY\n\r\n\r";
        } // RefreshInstructionText

        /// <summary>
        /// Delegate to ensure FORM3 (gv.frm3) is visible, active, focused, and frm3.textBox1 has focus
        /// </summary>
        public void frm3FocusMethod()
        {
            //SetWindowPos(global_variables.frm3.Handle, 0, 0, 0, 0, 0, 0x0040);
            if (gv.VSpy3ProcessHandle != null)
                _ = ShowWindow(gv.VSpy3ProcessHandle.MainWindowHandle, 7); //SW_SHOWMINNOACTIVE
            //SetActiveWindow(global_variables.frm3.Handle);
            //global_variables.frm3.textBox1.Focus();
        }

        public void UpdateProgressBar(int value)
        {
            if (gv.ConsoleTestMainForm.InvokeRequired)
            {
                _ = gv.ConsoleTestMainForm.Invoke(new Action<string>(AppendTextBox), new object[] { value });
                return;
            }
            gv.ConsoleTestMainForm.progressBar1.Value = value;
        }

        public void AppendTextBox(string value)
        {
            if (gv.ConsoleTestMainForm.InvokeRequired)
            {
                _ = gv.ConsoleTestMainForm.Invoke(new Action<string>(AppendTextBox), new object[] { value });
                return;
            }
            gv.ConsoleTestMainForm.textBoxRESULTS.Text += value;
        }

        /// <summary>
        /// launch VSpy3, wait for it to be ready, send "start" via TCP/IP, wait for it to be done, send "stop", wait for files to get written to disk
        /// </summary>
        private bool vSpyGatherPartNumbers_StateMachine()
        {
            switch (progressBar1.Value)
            {
                case 0:
                    UpdateProgressBar(1);
                    LaunchVSpy3();
                    break;

                case 1:
                    UpdateProgressBar(2);
                    break;

                case 2:
                    IPHostEntry IPHost = Dns.Resolve("127.0.0.1");
                    IPAddress[] addr = IPHost.AddressList;
                    EndPoint ep = new IPEndPoint(addr[0], 8255);
                    sock = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

                    try
                    {
                        sock.Connect(ep);
                        UpdateProgressBar(5);
                    }
                    catch (Exception)
                    {
                        Console.WriteLine("Exception in sock.Connect");
                        UpdateProgressBar(6);
                        //throw;//handle TCP socket errors here
                    }
                    break;

                case 6: //handle socket exception
                /* fall through until exception handler */
                case 5:
                    StartVSpyViaTCP();
                    UpdateProgressBar(7);
                    break;
                /*
                                case 7..29:
                                    // wait for it to be done
                                    break;
                */
                case 30:
                    StopVSpyViaTCP();
                    UpdateProgressBar(progressBar1.Value + 1);
                    break;

                case 31:
                    if (sock.Connected) sock.Shutdown(SocketShutdown.Both);
                    UpdateProgressBar(progressBar1.Value + 1);
                    break;

                case 32:
                    if (sock.Connected) sock.Close();
                    UpdateProgressBar(progressBar1.Value + 1);
                    break;
                /*
                            case 33..43:
                                // wait for it to be done
                                break;
                */
                case 44:
                    AppendTextBox("Used Text API to send START for Spy3 macro\n\r\n\r");
                    Console.WriteLine("Used Text API to send START for Spy3 macro");
                    UpdateProgressBar(45);
                    break;

                case 45:// idle state sits here until progressBar1.Value is set back to zero
                    return true;
                    //break;

                /* Default case just updates the progress bar and proceeds after the next timer tick
                 * note: timer is now 500ms
                 */
                default:
                    _ = gv.ConsoleTestMainForm.Invoke(myDelegate);
                    Console.WriteLine("unexpected or delay state reached in vSpyGatherPartNumbers: " + progressBar1.Value.ToString());
                    UpdateProgressBar(progressBar1.Value + 1);
                    break;
            }
            return false;
        }

        private void LaunchVSpy3()
        {
            Console.WriteLine("LaunchVSpy3 BEGIN");
            try
            {
                ProcessProperties.StartInfo.UseShellExecute = false;
                ProcessProperties.StartInfo.FileName = "c:\\Program Files (X86)\\Vehicle spy 3\\vspy3.exe";
                ProcessProperties.StartInfo.Arguments = "c:\\Android\\Data Directory\\Default\\Test71.vs3exe";
                ProcessProperties.StartInfo.WindowStyle = ProcessWindowStyle.Minimized; // change to .Hidden
                if (gv.VSpy3ProcessHandle == null)
                    gv.VSpy3ProcessHandle = Process.Start(ProcessProperties.StartInfo);
            }
            catch (Exception)
            {
                Console.WriteLine("Exception in LaunchVSpy3");
                //throw;
            }
            Console.WriteLine("LaunchVSpy3 end");
        }

        private void StartVSpyViaTCP()
        {
            try
            {
                Console.WriteLine("StartVSpyViaTCP BEGIN");
                byte[] RecvBytes = new byte[256];
                string Get = "start\r\n"; // Abnormal program termination
                byte[] ByteGet = Encoding.ASCII.GetBytes(Get);
                _ = sock.Send(ByteGet, ByteGet.Length, 0);
                int bytes = sock.Receive(RecvBytes, RecvBytes.Length, 0);
                string strRetPage = null;
                strRetPage += Encoding.ASCII.GetString(RecvBytes, 0, bytes);
                Console.WriteLine(strRetPage); // "ok start"
            }
            catch (Exception)
            {
                Console.WriteLine("Exception in StartVSpyViaTCP");
                //throw;
            }
            Console.WriteLine("StartVSpyViaTCP END");
        }

        private void StopVSpyViaTCP()
        {
            try
            {
                Console.WriteLine("StopVSpyViaTCP BEGIN");
                byte[] RecvBytes = new byte[256];
                string GGet = "stop\r\n";
                byte[] BByteGet = Encoding.ASCII.GetBytes(GGet);
                _ = sock.Send(BByteGet, BByteGet.Length, 0);

                int bbytes = sock.Receive(RecvBytes, RecvBytes.Length, 0);
                string sstrRetPage = null;
                sstrRetPage += Encoding.ASCII.GetString(RecvBytes, 0, bbytes);
                Console.WriteLine(sstrRetPage); // "ok stop"
            }
            catch (Exception)
            {
                Console.WriteLine("exception in StopVSpyViaTCP");
                //throw;
            }
            Console.WriteLine("StopVSpyViaTCP END");
        }

        // ********************************************************************************************************************
        // ****** Read Global Vriables from SHARP7 PLC MANIFEST READ TO SEQUENCE WHICH USB TO TEST ****************************
        // ********************************************************************************************************************
        // *******  CUPHOLDER USB ...... MOD CODE # 4301 ..... Broadcast String (13529875FW85) ********************************
        // *******  BODY USB............ MOD CODE # 3002 ..... Broadcast String (13529874FW86) ********************************
        // *******  BODY USB............ NO PART ............. Broadcast String (----****FT05) ********************************
        // *******  ENDCAP USB ......... MOD CODE # 1502 ..... Broadcast String (13525890FT12) ********************************
        // ********************************************************************************************************************
        // ********************************************************************************************************************

        // ***********************************************************************************************************
        // ************** Start of File Parsing Section  *************************************************************
        // ***********************************************************************************************************
        private bool ParseVSpyResultsFiles()
        {
            Console.WriteLine("ParseVSpyResultsFiles ENTER");
            try
            {
                ReadWCM();
                ReadSIB();
                ReadEOCM();
                ReadSEAT();
                ReadTBS();
            }
            catch (Exception)
            {
                Console.WriteLine("Exception while reading results files");
                //handle file read errors
                //throw;
            }
            try
            {
                ParseWCM();
                ParseSIB();
                ParseEOCM();
                ParseSeat();
                ParseTBS();
            }
            catch (Exception)
            {
                Console.WriteLine("Exception while parsing results data");
                //handle parsing failures
                //throw;
            }

            // Trial writing test log to file
            // string LOGstrFullFIleName = "c:/Android/Data Directory/Default/TestLog.txt";
            // StreamWriter srFileWriter = new StreamWriter(LOGstrFullFIleName);
            // srFileWriter.WriteLine(textBoxRESULTS.Text);
            // srFileWriter.Close();

            if (gv.FW_TESTER_TYPE == "CONSOLE")
                GenerateConsoleTestResultFile();
            else
                GenerateHeadlinerTestResultFile();

            textBoxRESULTS.Text += "Parsed Multiple.txt files\n\r\n\r";
            Console.WriteLine("ParseVSpyResultsFiles END");
            return true;
        } // ParseVSpyResultsFiles

        private static void GenerateHeadlinerTestResultFile()
        {
            //*******************************************************************************
            // ******************************************************************************
            // ******** Trial writing HEADLINER test result file for Larry to TX using Sharp7
            //*******************************************************************************
            //*******************************************************************************

            //string HL_strFullFIleName = "c:/Android/Data Directory/Default/HEADLINER_TESTER_1.txt";
            string HL_strFullFIleName = "c:/Android/Data Directory/Default/HLTestLog." + DateTime.Now.ToString("s") + ".txt";

            StreamWriter HL_FileWriter = new StreamWriter(HL_strFullFIleName);

            HL_FileWriter.WriteLine("ETC Headlin 1,");  // Tester Name(13) ETC Console 2,
            HL_FileWriter.WriteLine("06/29/21,"); // Test Date(10)  MM / DD / YEAR,
            HL_FileWriter.WriteLine("07:19:00,"); // Cycle Start Time Stamp(8), Military HR.MN.SC,
            HL_FileWriter.WriteLine("07:19:45,"); // Cycle Complete Time Stamp(8), Military HR.MN.SC,
            HL_FileWriter.WriteLine("0045,"); // Total Cycle Time(seconds)(4), 9999,
            HL_FileWriter.WriteLine("0000000355149,"); // Build ID # (10),  0000000355149,
            HL_FileWriter.WriteLine("0000004364960,"); // CSN # (13), Sequence #	0000004364960,
            HL_FileWriter.WriteLine("1234,"); // Test 1 Mod Code(4), 1234,
            HL_FileWriter.WriteLine("Test Channel 1 * *****,"); // Test 1 Channel Name(20),	Test Channel 1 * *****,
            HL_FileWriter.WriteLine("PASS,"); // Test 1 Result(4), PASS,
            HL_FileWriter.WriteLine("12.00,"); // Test 1 Data Volts DC(5), 	12.00,
            HL_FileWriter.WriteLine(">= 12.00,"); // Test 1 PASS Voltage Limit >= 12.00,
            HL_FileWriter.WriteLine("<= 12.00,"); // Test 1 FAIL Voltage Limit <= 12.00,
            HL_FileWriter.WriteLine("******************************,");  // Test 1 Result Comments(30),		******************************,
            HL_FileWriter.WriteLine("5678,");   // Test 2 Mod Code(4),	5678,
            HL_FileWriter.WriteLine("Test Channel 2 * *****,");  // Test 2 Channel Name(20),	Test Channel 2 * *****,
            HL_FileWriter.WriteLine("PASS,");   // Test 2 Result(4), PASS,
            HL_FileWriter.WriteLine("12.00,");   // Test 2 Data Volts DC(5), 12.00,
            HL_FileWriter.WriteLine(">= 12.00,");   // Test 2 PASS Voltage Limit >= 12.00,
            HL_FileWriter.WriteLine("<= 12.00,");   // Test 2 FAIL Voltage Limit <= 12.00,
            HL_FileWriter.WriteLine("******************************,");   // Test 2 Result Comments(30), 	******************************,
            HL_FileWriter.Close();
        }

        private static void GenerateConsoleTestResultFile()
        {
            //*******************************************************************************
            // ******************************************************************************
            // ******** Trial writing CONSOLE test result file for Larry to TX using Sharp7
            //*******************************************************************************
            //*******************************************************************************

            //string CONSOLE_strFullFIleName = "c:/Android/Data Directory/Default/CONSOLE_TESTER_2.txt";
            string CONSOLE_strFullFIleName = "c:/Android/Data Directory/Default/ConTestLog." + DateTime.Now.ToString("s") + ".txt";

            StreamWriter CONSOLE_FileWriter = new StreamWriter(CONSOLE_strFullFIleName);

            CONSOLE_FileWriter.WriteLine("ETC Console 2,");  // Tester Name(13) ETC Console 2,
            CONSOLE_FileWriter.WriteLine("06/29/21,"); // Test Date(10)  MM / DD / YEAR,
            CONSOLE_FileWriter.WriteLine("07:19:00,"); // Cycle Start Time Stamp(8), Military HR.MN.SC,
            CONSOLE_FileWriter.WriteLine("07:19:45,"); // Cycle Complete Time Stamp(8), Military HR.MN.SC,
            CONSOLE_FileWriter.WriteLine("0045,"); // Total Cycle Time(seconds)(4), 9999,
            CONSOLE_FileWriter.WriteLine("0000000355149,"); // Build ID # (10),  0000000355149,
            CONSOLE_FileWriter.WriteLine("0000004364960,"); // CSN # (13), Sequence #	0000004364960,

            ReportWCMResults(CONSOLE_FileWriter);
            ReportSIBResults(CONSOLE_FileWriter);
            ReportEOCMResults(CONSOLE_FileWriter);

            CONSOLE_FileWriter.WriteLine("1234,"); // Test 1 Mod Code(4), 1234,
            CONSOLE_FileWriter.WriteLine("Test Channel 1 * *****,"); // Test 1 Channel Name(20),	Test Channel 1 * *****,
            CONSOLE_FileWriter.WriteLine("PASS,"); // Test 1 Result(4), PASS,
            CONSOLE_FileWriter.WriteLine("12.00,"); // Test 1 Data Volts DC(5), 	12.00,
            CONSOLE_FileWriter.WriteLine(">= 12.00,"); // Test 1 PASS Voltage Limit >= 12.00,
            CONSOLE_FileWriter.WriteLine("<= 12.00,"); // Test 1 FAIL Voltage Limit <= 12.00,
            CONSOLE_FileWriter.WriteLine("******************************,");  // Test 1 Result Comments(30),		******************************,
            CONSOLE_FileWriter.WriteLine("5678,");   // Test 2 Mod Code(4),	5678,
            CONSOLE_FileWriter.WriteLine("Test Channel 2 * *****,");  // Test 2 Channel Name(20),	Test Channel 2 * *****,
            CONSOLE_FileWriter.WriteLine("PASS,");   // Test 2 Result(4), PASS,
            CONSOLE_FileWriter.WriteLine("12.00,");   // Test 2 Data Volts DC(5), 12.00,
            CONSOLE_FileWriter.WriteLine(">= 12.00,");   // Test 2 PASS Voltage Limit >= 12.00,
            CONSOLE_FileWriter.WriteLine("<= 12.00,");   // Test 2 FAIL Voltage Limit <= 12.00,
            CONSOLE_FileWriter.WriteLine("******************************,");   // Test 2 Result Comments(30), 	******************************,
            CONSOLE_FileWriter.Close();
        }

        private static void ReportEOCMResults(StreamWriter CONSOLE_FileWriter)
        {
            if (gv.EOCM.Contains("PASS"))  // Manual or MOD CODE selected
            {
                gv.EOCM_BASE_PN = gv.EOCM_BASE_PN.Trim();
                gv.EOCM_END_PN = gv.EOCM_END_PN.Trim();
                gv.EOCM_BOOT_PN = gv.EOCM_BOOT_PN.Trim();
                gv.EOCM_ASWID_PN = gv.EOCM_ASWID_PN.Trim();
                gv.EOCM_ADATAID_PN = gv.EOCM_ADATAID_PN.Trim();

                CONSOLE_FileWriter.WriteLine("3301,"); // EOCM MOD CODE
                CONSOLE_FileWriter.WriteLine(gv.EOCM_BASE_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.EOCM_END_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.EOCM_BOOT_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.EOCM_ASWID_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.EOCM_ADATAID_PN + ",");
            }
        }

        private static void ReportSIBResults(StreamWriter CONSOLE_FileWriter)
        {
            if (gv.SIB.Contains("PASS"))  // Manual or MOD CODE selected
            {
                gv.SIB_BASE_PN = gv.SIB_BASE_PN.Trim();
                gv.SIB_END_PN = gv.SIB_END_PN.Trim();
                gv.SIB_BOOT_PN = gv.SIB_BOOT_PN.Trim();
                gv.SIB_ASWID_PN = gv.SIB_ASWID_PN.Trim();
                gv.SIB_ADATAID_PN = gv.SIB_ADATAID_PN.Trim();

                CONSOLE_FileWriter.WriteLine("2701,"); // SIB MOD CODE
                CONSOLE_FileWriter.WriteLine(gv.SIB_BASE_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.SIB_END_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.SIB_BOOT_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.SIB_ASWID_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.SIB_ADATAID_PN + ",");
            }
        }

        private static void ReportWCMResults(StreamWriter CONSOLE_FileWriter)
        {
            if (gv.WCM.Contains("PASS"))  // Manual or MOD CODE selected
            {
                gv.WCM_BASE_PN = gv.WCM_BASE_PN.Trim();
                gv.WCM_END_PN = gv.WCM_END_PN.Trim();
                gv.WCM_BOOT_PN = gv.WCM_BOOT_PN.Trim();
                gv.WCM_ASWID_PN = gv.WCM_ASWID_PN.Trim();
                gv.WCM_ADATAID_PN = gv.WCM_ADATAID_PN.Trim();

                CONSOLE_FileWriter.WriteLine("2901,"); // MCN MOD CODE
                CONSOLE_FileWriter.WriteLine(gv.WCM_BASE_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.WCM_END_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.WCM_BOOT_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.WCM_ASWID_PN + ",");
                CONSOLE_FileWriter.WriteLine(gv.WCM_ADATAID_PN + ",");
            }
        }

        private void ParseTBS()
        {
            if (gv.TBS.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //****************************************************************************************
                //***** PARSE THE LIN TRAILER SWITCH TEST RESULTS FROM THE (Trailer Switch.txt) FILE
                //****************************************************************************************

                // now locate Resault of PN read (0 = No Read) (1 = Able to read all 5 Part Numbers)
                int LIN_TBS_Result = textBoxRESULTS.Text.IndexOf("Trailer Switch LIN, ");
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Location of Trailer Brake Switch LIN,  = " + LIN_TBS_Result + "\n\r\n\r";
                string LIN_TBS_ResultS = textBoxRESULTS.Text.Substring((LIN_TBS_Result), 32);
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Contents of Trailer Brake Switch LIN,  = " + LIN_TBS_ResultS + "\n\r\n\r";

                if (textBoxRESULTS.Text.Contains("LIN TRAILER BRAKE SWITCH READ DETECTION PASSED"))
                {
                    // Do Nothing
                }
                else // One Shot
                {
                    if (textBoxRESULTS.Text.Contains("Trailer Switch LIN, Payload 31, 0, Payload 32, 0")) // Ed Needs to add results or Time and date so I know it is same test as PN checks
                    {
                        gv.TBS = "FAIL";
                        button_LIN_TBS.BackColor = Color.Orange;
                        textBoxRESULTS.Text += "LIN TRAILER BRAKE SWITCH READ DETECTION Failed.  No LIN TRAILER BRAKE SWITCH Detected\n\r\n\r";
                    }
                    else // One Shot
                    {
                        gv.TBS = "PASS";
                        button_LIN_TBS.BackColor = Color.Aquamarine;
                        textBoxRESULTS.Text += "LIN TRAILER BRAKE SWITCH READ DETECTION PASSED\n\r\n\r";

                        gv.LIN_TBS = "PASS";
                    }
                }
            }
        }

        private void ParseSeat()
        {
            if (gv.SEAT.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //****************************************************************************************
                //***** PARSE THE LIN HEATED SEAT SWITCH TEST RESULTS FROM THE (HeatedSeatSwitch.txt) FILE
                //****************************************************************************************

                // now locate Resault of PN read (0 = No Read) (1 = Able to read all 5 Part Numbers)
                int LIN_HSS_Result = textBoxRESULTS.Text.IndexOf("Heated Seat LIN, ");
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Location of EOCM Module Part Number Read = " + LIN_HSS_Result + "\n\r\n\r";
                string LIN_HSS_ResultS = textBoxRESULTS.Text.Substring((LIN_HSS_Result), 32);
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Contents of EOCM Module Part Number Read = " + LIN_HSS_ResultS + "\n\r\n\r";

                if (textBoxRESULTS.Text.Contains("LIN HEATED SEAT SWITCH READ DETECTION PASSED"))
                {
                    // Do Nothing
                }
                else // One Shot
                {
                    if (textBoxRESULTS.Text.Contains("Heated Seat LIN, Payload 15, 0, Payload 35,0")) // Ed Needs to add results or Time and date so I know it is same test as PN checks
                    {
                        gv.SEAT = "FAIL";
                        button_LIN_Heated_Seat_Switch.BackColor = Color.Orange;
                        textBoxRESULTS.Text += "LIN HEATED SEAT SWITCH READ DETECTION Failed.  No LIN Heated Seat Sw. Detected\n\r\n\r";
                    }
                    else // One Shot
                    {
                        gv.SEAT = "PASS";
                        button_LIN_Heated_Seat_Switch.BackColor = Color.Aquamarine;
                        textBoxRESULTS.Text += "LIN HEATED SEAT SWITCH READ DETECTION PASSED\n\r\n\r";

                        gv.LIN_SEAT_SW = "PASS";
                    }
                }
            }
        }

        private void ParseEOCM()
        {
            if (gv.EOCM.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //*********************************************************************
                //***** PARSE THE EOCM PART NUMBERS FROM THE (EOCMPNsCAN4.txt) FILE
                //*********************************************************************

                // now locate Resault of PN read (0 = No Read) (1 = Able to read all 5 Part Numbers)
                int EOCM_Result = textBoxRESULTS.Text.IndexOf("EOCM Part Numbers, Test restut: ");
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Location of EOCM Module Part Number Read = " + EOCM_Result + "\n\r\n\r";
                string EOCM_ResultS = textBoxRESULTS.Text.Substring((EOCM_Result), 33);
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Contents of EOCM Module Part Number Read = " + EOCM_ResultS + "\n\r\n\r";

                if (textBoxRESULTS.Text.Contains("EOCM Module Part Number Read Passed"))
                {
                    // Do Nothing
                }
                else // Parse out the Module Part Numbers
                {
                    if (EOCM_ResultS.Contains("1")) // 1 = Able to read all 5 Part Numbers
                    {
                        TextBox_Date_of_PN_Read.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 34), 10);
                        TextBox_Time_of_PN_Read.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 45), 14);
                        textBoxEOCM_BaseModelPartNumber8.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 62), 8);
                        textBoxEOCM_AppDataID10.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 71), 10);
                        textBoxEOCM_AppSWID10.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 84), 11);
                        textBoxEOCM_BootSWID8.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 95), 9);
                        textBoxEOCM_EndModelPartNumber8.Text = textBoxRESULTS.Text.Substring((EOCM_Result + 105), 10);

                        buttonEOCM.BackColor = Color.Aquamarine;

                        textBoxRESULTS.Text += "EOCM Module Part Number Read Passed\n\r\n\r";

                        gv.EOCM = "PASS";
                        gv.EOCM_BASE_PN = textBoxEOCM_BaseModelPartNumber8.Text;
                        gv.EOCM_END_PN = textBoxEOCM_EndModelPartNumber8.Text;
                        gv.EOCM_BOOT_PN = textBoxEOCM_BootSWID8.Text;
                        gv.EOCM_ASWID_PN = textBoxEOCM_AppSWID10.Text;
                        gv.EOCM_ADATAID_PN = textBoxEOCM_AppDataID10.Text;
                        gv.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
                        gv.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;
                    }
                    else // 0 = No Read
                    {
                        textBoxEOCM_AppDataID10.Text = " NO READ ";
                        textBoxEOCM_AppSWID10.Text = " NO READ ";
                        textBoxEOCM_BootSWID8.Text = " NO READ ";
                        textBoxEOCM_EndModelPartNumber8.Text = " NO READ ";
                        textBoxEOCM_BaseModelPartNumber8.Text = " NO READ ";

                        textBoxRESULTS.Text += "EOCM Module Part Number Read Failed.  No EOCM Module Detected\n\r\n\r";

                        buttonEOCM.BackColor = Color.Orange;
                    }
                }
            }
        }

        private void ParseSIB()
        {
            if (gv.SIB.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //*********************************************************************
                //***** PARSE THE SIB PART NUMBERS FROM THE (SIBPNs.txt) FILE
                //*********************************************************************

                // now locate Resault of PN read (0 = No Read) (1 = Able to read all 5 Part Numbers)
                int SIB_Result = textBoxRESULTS.Text.IndexOf("SIB Part Numbers, Test restut: ");
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Location of SIB Module Part Number Read = " + SIB_Result + "\n\r\n\r";
                string SIB_ResultS = textBoxRESULTS.Text.Substring((SIB_Result), 32);
                textBoxRESULTS.Text = textBoxRESULTS.Text + "Contents of SIB Module Part Number Read = " + SIB_ResultS + "\n\r\n\r";

                if (textBoxRESULTS.Text.Contains("SIB Module Part Number Read Passed"))
                {
                    // Do Nothing
                }
                else // Parse out the Module Part Numbers
                {
                    if (SIB_ResultS.Contains("1")) // 1 = Able to read all 5 Part Numbers
                    {
                        TextBox_Date_of_PN_Read.Text = textBoxRESULTS.Text.Substring((SIB_Result + 34), 10);
                        TextBox_Time_of_PN_Read.Text = textBoxRESULTS.Text.Substring((SIB_Result + 44), 15);
                        textBoxSIB_AppDataID10.Text = textBoxRESULTS.Text.Substring((SIB_Result + 61), 10);
                        textBoxSIB_AppSWID10.Text = textBoxRESULTS.Text.Substring((SIB_Result + 73), 10);
                        textBoxSIB_BootSWID8.Text = textBoxRESULTS.Text.Substring((SIB_Result + 84), 9);
                        textBoxSIB_EndModelPartNumber8.Text = textBoxRESULTS.Text.Substring((SIB_Result + 94), 9);
                        textBoxSIB_BaseModelPartNumber8.Text = textBoxRESULTS.Text.Substring((SIB_Result + 104), 10);

                        buttonSIB.BackColor = Color.Aquamarine;

                        textBoxRESULTS.Text += "SIB Module Part Number Read Passed\n\r\n\r";

                        gv.SIB = "PASS";
                        gv.SIB_BASE_PN = textBoxSIB_BaseModelPartNumber8.Text;
                        gv.SIB_END_PN = textBoxSIB_EndModelPartNumber8.Text;
                        gv.SIB_BOOT_PN = textBoxSIB_BootSWID8.Text;
                        gv.SIB_ASWID_PN = textBoxSIB_AppSWID10.Text;
                        gv.SIB_ADATAID_PN = textBoxSIB_AppDataID10.Text;
                        gv.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
                        gv.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;
                    }
                    else // 0 = No Read
                    {
                        textBoxRESULTS.Text += "SIB Module Part Number Read Failed.  No SIB Module Detected\n\r\n\r";

                        textBoxSIB_AppDataID10.Text = " NO READ ";
                        textBoxSIB_AppSWID10.Text = " NO READ ";
                        textBoxSIB_BootSWID8.Text = " NO READ ";
                        textBoxSIB_EndModelPartNumber8.Text = " NO READ ";
                        textBoxSIB_BaseModelPartNumber8.Text = " NO READ ";

                        buttonSIB.BackColor = Color.Orange;
                    }
                }
            }
        }

        private void ParseWCM()
        {
            //if (global_variables.WCM.Contains("YELO"))  // Manual or MOD CODE selected

            //*********************************************************************
            //***** PARSE THE WCM PART NUMBERS FROM THE (WCMPNs.txt) FILE
            //*********************************************************************

            // now locate Resault of PN read (0 = No Read) (1 = Able to read all 5 Part Numbers)
            int WCM_Result = textBoxRESULTS.Text.IndexOf("WCM Part Numbers, Test restut: ");
            textBoxRESULTS.Text = textBoxRESULTS.Text + "Location of WCM Module Part Number Read = " + WCM_Result + "\n\r\n\r";
            string WCM_ResultS = textBoxRESULTS.Text.Substring(WCM_Result, 32);
            textBoxRESULTS.Text = textBoxRESULTS.Text + "Contents of WCM Module Part Number Read = " + WCM_ResultS + "\n\r\n\r";

            if (textBoxRESULTS.Text.Contains("WCM Module Part Number Read Passed"))
            {
                // Do Nothing
            }
            else // Parse out the Module Part Numbers
            {
                if (WCM_ResultS.Contains("1")) // 1 = Able to read all 5 Part Numbers
                {
                    TextBox_Date_of_PN_Read.Text = textBoxRESULTS.Text.Substring((WCM_Result + 34), 10);
                    TextBox_Time_of_PN_Read.Text = textBoxRESULTS.Text.Substring((WCM_Result + 44), 15);
                    textBoxWCM_AppDataID10.Text = textBoxRESULTS.Text.Substring((WCM_Result + 61), 10);
                    textBoxWCM_AppSWID10.Text = textBoxRESULTS.Text.Substring((WCM_Result + 73), 10);
                    textBoxWCM_BootSWID8.Text = textBoxRESULTS.Text.Substring((WCM_Result + 84), 9);
                    textBoxWCM_EndModelPartNumber8.Text = textBoxRESULTS.Text.Substring((WCM_Result + 94), 9);
                    textBoxWCM_BaseModelPartNumber8.Text = textBoxRESULTS.Text.Substring((WCM_Result + 104), 10);

                    buttonWCM.BackColor = Color.Aquamarine;
                    textBoxRESULTS.Text += "WCM Module Part Number Read Passed\n\r\n\r";
                    gv.WCM = "PASS";
                    gv.WCM_BASE_PN = textBoxWCM_BaseModelPartNumber8.Text;
                    gv.WCM_END_PN = textBoxWCM_EndModelPartNumber8.Text;
                    gv.WCM_BOOT_PN = textBoxWCM_BootSWID8.Text;
                    gv.WCM_ASWID_PN = textBoxWCM_AppSWID10.Text;
                    gv.WCM_ADATAID_PN = textBoxWCM_AppDataID10.Text;
                    gv.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
                    gv.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;
                }
                else // 0 = No Read
                {
                    textBoxRESULTS.Text += "WCM Module Part Number Read Failed.  No WCM Module Detected\n\r\n\r";

                    textBoxWCM_AppDataID10.Text = " NO READ ";
                    textBoxWCM_AppSWID10.Text = " NO READ ";
                    textBoxWCM_BootSWID8.Text = " NO READ ";
                    textBoxWCM_EndModelPartNumber8.Text = " NO READ ";
                    textBoxWCM_BaseModelPartNumber8.Text = " NO READ ";

                    buttonWCM.BackColor = Color.Orange;
                }
            }
        }

        private void ReadTBS()
        {
            if (gv.TBS.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //******************************************************
                //******* TBS - LIN Trailer Brake Switch Detection File
                //******************************************************
                string TBSstrFullFIleName = "c:/Android/Data Directory/Default/Trailer Switch.txt";
                StreamReader TBSsrFileReader = new StreamReader(TBSstrFullFIleName);
                textBoxRESULTS.Text += TBSsrFileReader.ReadToEnd();
                //srFileReader.Close();
            }
        }

        private void ReadSEAT()
        {
            if (gv.SEAT.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //*****************************************************
                //******* SEAT - LIN Heated Seat Switch Detection File
                //*****************************************************
                string SEATstrFullFIleName = "c:/Android/Data Directory/Default/HeatedSeat.txt";
                StreamReader SEATsrFileReader = new StreamReader(SEATstrFullFIleName);
                textBoxRESULTS.Text += SEATsrFileReader.ReadToEnd();
                //srFileReader.Close();
            }
        }

        private void ReadEOCM()
        {
            if (gv.EOCM.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //***********************************
                //******* EOCM Part Number File
                //***********************************
                string EOCMstrFullFIleName = "c:/Android/Data Directory/Default/EOCMPNsCAN4.txt";
                StreamReader EOCMsrFileReader = new StreamReader(EOCMstrFullFIleName);
                textBoxRESULTS.Text += EOCMsrFileReader.ReadToEnd();
                //srFileReader.Close();
            }
        }

        private void ReadSIB()
        {
            if (gv.SIB.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //***********************************
                //******* SIB Part Number File
                //***********************************
                string SIBstrFullFIleName = "c:/Android/Data Directory/Default/SIBPNs.txt";
                StreamReader SIBsrFileReader = new StreamReader(SIBstrFullFIleName);
                textBoxRESULTS.Text += SIBsrFileReader.ReadToEnd();
                // srFileReader.Close();
            }
        }

        private void ReadWCM()
        {
            if (gv.WCM.Contains("YELO"))  // Manual or MOD CODE selected
            {
                //***********************************
                //******* WCM Part Number File
                //***********************************
                string WCMstrFullFIleName = "c:/Android/Data Directory/Default/WCMPNs.txt";
                StreamReader srFileReader = new StreamReader(WCMstrFullFIleName);
                textBoxRESULTS.Text += srFileReader.ReadToEnd();
                // srFileReader.Close();
            }
        }

        // ****************** End of 700 ms Timer Tick Loop *************************************************
        // ***************************************************************************************************

        private void buttonViewResults_Click(object sender, EventArgs e)  // FOR DEMO ONLY!  VIEW RESULTS
        {
            timerForm3_Connect55_way.Stop();
            gv.ConsoleTestResultForm.Show();
        }

        private void ShowDiagnosticForm_Click(object sender, EventArgs e) // FOR DEMO ONLY!  START ANALOG TEST
        {
            timerForm3_Connect55_way.Stop();
            gv.DiagnosticForm.Show();
        }

        private void buttonOperatorAbort_Click(object sender, EventArgs e)// OPERATOR ABORT TEST CYCLE
        {
            timerForm3_Connect55_way.Stop();
            gv.ConsoleTestResultForm.Show();
        }

        private void buttonExit_Click(object sender, EventArgs e)
        {
            timerForm3_Connect55_way.Stop();
            gv.bCloseProgram = true; // TODO: only set to true if developer means it!!
            if (gv.VSpy3ProcessHandle != null)
                _ = gv.VSpy3ProcessHandle.CloseMainWindow();
            Close();
        }
    }// ********************************************************************************************
} // *****************************************************