﻿using AIOUSBNet;  // namespace exposes AIOUSB Class interface
using System;
using System.Drawing;
using System.Windows.Forms;

namespace Sample1
{
    public partial class ConsoleTestResultsForm : Form
    {
        public ConsoleTestResultsForm()
        {
            InitializeComponent();
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            // Display Software Version
            labelSoftware_Version.Text = gv.SOFTWARE_VERSION;

            // Check for V_BADGE_ACCESS
            if (gv.BADGE_ACCESS.Contains("Supervisor")) // Enable Manual Option Selection Keys on the touch screen . Must Default to non Supervisor after Cycle Complete
            {
                button18.Enabled = (true);
            }
            else // // Disable Manual Option Selection Keys on the touch screen
            {
            }

            // CONSOLE MANIFEST - Highline (default)
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,13529875FW85,4301,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,13592452FW74,3501,84952174FW83,4201,84786104FW68,3101,84960563M33V,3301,13537143M08L,2901,";

            // PARSE OUT THE CSN #
            gv.CSN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm2VIN.Text = gv.CSN;

            // **************************************************
            // **** CHECK GLOBAL VARIABLES FOR TEST RESULTS *****
            //***************************************************

            if (gv.WCM.Contains("PASS"))
            {
                button7.BackColor = Color.Aquamarine; // PN - Part Number
                button30.BackColor = Color.Aquamarine; // WCM - PASS
            }
            else
            {
                if (gv.WCM.Contains("YELO"))
                {
                    button7.BackColor = Color.Orange; // PN - Part Number
                    button30.BackColor = Color.Orange; // WCM - FAIL
                    gv.WCM = "FAIL";
                }

                if (gv.WCM.Contains("FAIL"))
                {
                    button7.BackColor = Color.Orange; // PN - Part Number
                    button30.BackColor = Color.Orange; // WCM - FAIL
                    gv.WCM = "FAIL";
                }
            }

            if (gv.SIB.Contains("PASS"))
            {
                button7.BackColor = Color.Aquamarine; // PN - Part Number
                button28.BackColor = Color.Aquamarine; // SIB - PASS
            }
            else
            {
                if (gv.SIB.Contains("YELO"))
                {
                    button7.BackColor = Color.Orange; // PN - Part Number
                    button28.BackColor = Color.Orange; // SIB - FAIL
                    gv.SIB = "FAIL";
                }

                if (gv.SIB.Contains("FAIL"))
                {
                    button7.BackColor = Color.Orange; // PN - Part Number
                    button28.BackColor = Color.Orange; // SIB - FAIL
                    gv.SIB = "FAIL";
                }
            }

            if (gv.EOCM.Contains("PASS"))
            {
                button7.BackColor = Color.Aquamarine; // PN - Part Number
                button24.BackColor = Color.Aquamarine; // EOCM - PASS
            }
            else
            {
                if (gv.EOCM.Contains("YELO"))
                {
                    button7.BackColor = Color.Orange; // PN - Part Number
                    button24.BackColor = Color.Orange; // SIB - FAIL
                    gv.EOCM = "FAIL";
                }

                if (gv.EOCM.Contains("FAIL"))
                {
                    button7.BackColor = Color.Orange; // PN - Part Number
                    button24.BackColor = Color.Orange; // SIB - FAIL
                    gv.EOCM = "FAIL";
                }
            }

            if (gv.SEAT.Contains("PASS"))
            {
                button13.BackColor = Color.Aquamarine; // SEAT - PASS
            }
            else
            {
                if (gv.SEAT.Contains("YELO"))
                {
                    button13.BackColor = Color.Orange; //
                    gv.SEAT = "FAIL";
                }

                if (gv.SEAT.Contains("FAIL"))
                {
                    button13.BackColor = Color.Orange; //
                    gv.SEAT = "FAIL";
                }
            }

            if (gv.TBS.Contains("PASS"))
            {
                button20.BackColor = Color.Aquamarine; // TBS - PASS
            }
            else
            {
                if (gv.TBS.Contains("YELO"))
                {
                    button20.BackColor = Color.Orange; // PN - Part Number
                    gv.TBS = "FAIL";
                }

                if (gv.TBS.Contains("FAIL"))
                {
                    button20.BackColor = Color.Orange; // PN - Part Number
                    gv.TBS = "FAIL";
                }
            }

            if (gv.LAMP.Contains("PASS")) // LAMP TEST RESULTS
            {
                button27.BackColor = Color.Aquamarine; //  PASS
            }
            else
            {
                if (gv.LAMP.Contains("YELO"))
                {
                    button27.BackColor = Color.Orange; // FAIL
                    gv.LAMP = "FAIL";
                }

                if (gv.LAMP.Contains("FAIL"))
                {
                    button27.BackColor = Color.Orange; // FAIL
                    gv.LAMP = "FAIL";
                }
            }

            if (gv.PEPS.Contains("PASS")) // PEPS ANTENNA TEST RESULT
            {
                button18.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.PEPS.Contains("YELO"))
                {
                    button18.BackColor = Color.Orange; // FAIL
                    gv.PEPS = "FAIL";
                }

                if (gv.PEPS.Contains("FAIL"))
                {
                    button18.BackColor = Color.Orange; // FAIL
                    gv.PEPS = "FAIL";
                }
            }

            if (gv.IMOB.Contains("PASS")) // IMMOBILIZER ANTENNA TEST RESULT
            {
                button22.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.IMOB.Contains("YELO"))
                {
                    button22.BackColor = Color.Orange; // FAIL
                    gv.IMOB = "FAIL";
                }

                if (gv.IMOB.Contains("FAIL"))
                {
                    button22.BackColor = Color.Orange; // FAIL
                    gv.IMOB = "FAIL";
                }
            }

            if (gv.HVPO.Contains("PASS")) // HIGH VOLTAGE POWER OUTLET
            {
                button34.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.HVPO.Contains("YELO"))
                {
                    button34.BackColor = Color.Orange; // FAIL
                    gv.HVPO = "FAIL";
                }

                if (gv.HVPO.Contains("FAIL"))
                {
                    button34.BackColor = Color.Orange; // FAIL
                    gv.HVPO = "FAIL";
                }
            }

            if (gv.ENDCAP_USB_TEST.Contains("PASS")) // ENDCAP USB TEST RESULT
            {
                buttonEndcapUSB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.ENDCAP_USB_TEST.Contains("YELO"))
                {
                    buttonEndcapUSB.BackColor = Color.Orange; // FAIL
                    gv.ENDCAP_USB_TEST = "FAIL";
                }

                if (gv.ENDCAP_USB_TEST.Contains("FAIL"))
                {
                    buttonEndcapUSB.BackColor = Color.Orange; // FAIL
                    gv.ENDCAP_USB_TEST = "FAIL";
                }
            }

            if (gv.ENDCAP_USB_SCAN.Contains("PASS")) // ENDCAP USB RFID BADGE SCAN RESULT
            {
                buttonEndcapResult.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.ENDCAP_USB_SCAN.Contains("YELO"))
                {
                    buttonEndcapResult.BackColor = Color.Orange; // FAIL
                    gv.ENDCAP_USB_SCAN = "FAIL";
                }

                if (gv.ENDCAP_USB_SCAN.Contains("FAIL"))
                {
                    buttonEndcapResult.BackColor = Color.Orange; // FAIL
                    gv.ENDCAP_USB_SCAN = "FAIL";
                }
            }

            if (gv.BODY_USB_TEST.Contains("PASS")) // BODY USB TEST RESULT
            {
                buttonBodyUSB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.BODY_USB_TEST.Contains("YELO"))
                {
                    buttonBodyUSB.BackColor = Color.Orange; // FAIL
                    gv.BODY_USB_TEST = "FAIL";
                }

                if (gv.BODY_USB_TEST.Contains("FAIL"))
                {
                    buttonBodyUSB.BackColor = Color.Orange; // FAIL
                    gv.BODY_USB_TEST = "FAIL";
                }
            }

            if (gv.BODY_USB_TEST.Contains("PASS")) // BODY USB RFID BADGE SCAN RESULT
            {
                buttonBodyResult.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.BODY_USB_TEST.Contains("YELO"))
                {
                    buttonBodyResult.BackColor = Color.Orange; // FAIL
                    gv.BODY_USB_TEST = "FAIL";
                }

                if (gv.BODY_USB_TEST.Contains("FAIL"))
                {
                    buttonBodyResult.BackColor = Color.Orange; // FAIL
                    gv.BODY_USB_TEST = "FAIL";
                }
            }

            if (gv.CUPHOLDER_USB_TEST.Contains("PASS")) // CUPHOLDER USB TEST RESULT
            {
                buttonCupholderUSB.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.CUPHOLDER_USB_TEST.Contains("YELO"))
                {
                    buttonCupholderUSB.BackColor = Color.Orange; // FAIL
                    gv.CUPHOLDER_USB_TEST = "FAIL";
                }

                if (gv.CUPHOLDER_USB_TEST.Contains("FAIL"))
                {
                    buttonCupholderUSB.BackColor = Color.Orange; // FAIL
                    gv.CUPHOLDER_USB_TEST = "FAIL";
                }
            }

            if (gv.CUPHOLDER_USB_SCAN.Contains("PASS")) // CUPHOLDER USB RFID BADGE SCAN RESULT
            {
                buttonCupholder.BackColor = Color.Aquamarine; // PASS
            }
            else
            {
                if (gv.CUPHOLDER_USB_TEST.Contains("YELO"))
                {
                    buttonCupholder.BackColor = Color.Orange; // FAIL
                    gv.CUPHOLDER_USB_TEST = "FAIL";
                }

                if (gv.CUPHOLDER_USB_TEST.Contains("FAIL"))
                {
                    buttonCupholder.BackColor = Color.Orange; // FAIL
                    gv.CUPHOLDER_USB_TEST = "FAIL";
                }
            }

            textBoxOperatorPrompts.Text = ""; // Clear Screen

            timer1.Start();
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
        }

        private void buttonOK_Click(object sender, EventArgs e) // OK BUTTON
        {
            timer1.Stop();
            if (gv.ConsoleTestMainForm != null)
            {
                gv.ConsoleTestMainForm.Close();
            }
        }

        private void button13_Click(object sender, EventArgs e) // SEAT
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button13.BackColor == Color.Yellow)
            {
                button13.BackColor = Color.LightGray;
                gv.SEAT = "GRAY";
            }
            else
            {
                button13.BackColor = Color.Yellow;
                gv.SEAT = "YELO";
            }
        }

        private void button18_Click(object sender, EventArgs e) // PEPS
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button18.BackColor == Color.Yellow)
            {
                button18.BackColor = Color.LightGray;
                gv.PEPS = "GRAY";
            }
            else
            {
                button18.BackColor = Color.Yellow;
                gv.PEPS = "YELO";
            }
        }

        private void button28_Click(object sender, EventArgs e) // SIB
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button28.BackColor == Color.Yellow)
            {
                button28.BackColor = Color.LightGray;
                gv.SIB = "GRAY";
            }
            else
            {
                button28.BackColor = Color.Yellow;
                gv.SIB = "YELO";
            }
        }

        private void button20_Click(object sender, EventArgs e) // TBS
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button20.BackColor == Color.Yellow)
            {
                button20.BackColor = Color.LightGray;
                gv.TBS = "GRAY";
            }
            else
            {
                button20.BackColor = Color.Yellow;
                gv.TBS = "YELO";
            }
        }

        private void button27_Click(object sender, EventArgs e) // LAMP
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button27.BackColor == Color.Yellow)
            {
                button27.BackColor = Color.LightGray;
                gv.LAMP = "GRAY";
            }
            else
            {
                button27.BackColor = Color.Yellow;
                gv.LAMP = "YELO";
            }
        }

        private void button22_Click(object sender, EventArgs e) // IMOB
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button22.BackColor == Color.Yellow)
            {
                button22.BackColor = Color.LightGray;
                gv.IMOB = "GRAY";
            }
            else
            {
                button22.BackColor = Color.Yellow;
                gv.IMOB = "YELO";
            }
        }

        private void button30_Click(object sender, EventArgs e) // WCM
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button30.BackColor == Color.Yellow)
            {
                button30.BackColor = Color.LightGray;
                gv.WCM = "GRAY";
            }
            else
            {
                button30.BackColor = Color.Yellow;
                gv.WCM = "YELO";
            }
        }

        private void button24_Click(object sender, EventArgs e) // EOCM
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button24.BackColor == Color.Yellow)
            {
                button24.BackColor = Color.LightGray;
                gv.EOCM = "GRAY";
            }
            else
            {
                button24.BackColor = Color.Yellow;
                gv.EOCM = "YELO";
            }
        }

        private void buttonBodyUSB_Click(object sender, EventArgs e)  // BODY USB
        {
            gv.Manifest = "MANUAL ENTRY";

            if (buttonBodyUSB.BackColor == Color.Yellow)
            {
                buttonBodyUSB.BackColor = Color.LightGray;
                buttonBodyResult.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }
            else
            {
                buttonBodyUSB.BackColor = Color.Yellow;
                buttonBodyResult.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
            }
        }

        private void buttonEndcapUSB_Click(object sender, EventArgs e) // ENDCAP USB
        {
            gv.Manifest = "MANUAL ENTRY";

            if (buttonEndcapUSB.BackColor == Color.Yellow)
            {
                buttonEndcapUSB.BackColor = Color.LightGray;
                buttonEndcapResult.BackColor = Color.LightGray;
                gv.ENDCAP_USB_SCAN = "GRAY";
                gv.ENDCAP_USB_TEST = "GRAY";
            }
            else
            {
                buttonEndcapUSB.BackColor = Color.Yellow;
                buttonEndcapResult.BackColor = Color.Yellow;
                gv.ENDCAP_USB_SCAN = "YELO";
                gv.ENDCAP_USB_TEST = "YELO";
            }
        }

        private void buttonBodyScan_Click(object sender, EventArgs e)
        {
            gv.Manifest = "MANUAL ENTRY"; // BODY USB

            if (buttonBodyResult.BackColor == Color.Yellow)
            {
                buttonBodyResult.BackColor = Color.LightGray;
                buttonBodyUSB.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }
            else
            {
                buttonBodyResult.BackColor = Color.Yellow;
                buttonBodyUSB.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
            }
        }

        private void buttonEndcapScan_Click(object sender, EventArgs e)
        {
            gv.Manifest = "MANUAL ENTRY"; // ENDCAP USB

            if (buttonEndcapResult.BackColor == Color.Yellow)
            {
                buttonEndcapResult.BackColor = Color.LightGray;
                buttonEndcapUSB.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }
            else
            {
                buttonEndcapResult.BackColor = Color.Yellow;
                buttonEndcapUSB.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
            }
        }

        private void buttonClear_Click(object sender, EventArgs e) // Clear Options Button Pressed
        {
            gv.Manifest = "MANUAL ENTRY";

            button13.BackColor = Color.LightGray;
            button18.BackColor = Color.LightGray;
            button28.BackColor = Color.LightGray;
            button20.BackColor = Color.LightGray;
            button27.BackColor = Color.LightGray;
            button22.BackColor = Color.LightGray;
            button30.BackColor = Color.LightGray;
            button24.BackColor = Color.LightGray;
            buttonBodyUSB.BackColor = Color.LightGray;
            buttonEndcapUSB.BackColor = Color.LightGray;
            buttonBodyResult.BackColor = Color.LightGray;
            buttonEndcapResult.BackColor = Color.LightGray;
            button7.BackColor = Color.LightGray;
            buttonCupholderUSB.BackColor = Color.LightGray;
            buttonCupholder.BackColor = Color.LightGray;
            button34.BackColor = Color.LightGray;
        }

        private void buttonHighlineManifest_Click(object sender, EventArgs e)
        {
            gv.Manifest = "HIGHLINE MANUAL ENTRY";

            //   button31.BackColor = Color.Yellow;// PN

            // CONSOLE MANIFEST - Highline
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,13529875FW85,4301,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,13592452FW74,3501,84952174FW83,4201,84786104FW68,3101,84960563M33V,3301,13537143M08L,2901,";

            // ******************************************
            // ********* MOD codes for USB test *********
            // ******************************************

            if (Manifest_Options.Text.Contains(",4301,")) // Search Manifest for Modcode (Cupholder USB)
            {
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3002,")) // Search Manifest for Modcode (Body USB)
            {
                buttonBodyUSB.BackColor = Color.Yellow;
                buttonBodyResult.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
            }
            else
            {
                buttonBodyUSB.BackColor = Color.LightGray;
                buttonBodyResult.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1502,")) // Search Manifest for Modcode (Endcap USB)
            {
                buttonEndcapUSB.BackColor = Color.Yellow;
                buttonEndcapResult.BackColor = Color.Yellow;
                gv.ENDCAP_USB_SCAN = "YELO";
                gv.ENDCAP_USB_TEST = "YELO";
            }
            else
            {
                buttonEndcapUSB.BackColor = Color.LightGray;
                buttonEndcapResult.BackColor = Color.LightGray;
                gv.ENDCAP_USB_SCAN = "GRAY";
                gv.ENDCAP_USB_TEST = "GRAY";
            }

            // ******************************************
            // ********* All Other MOD codes ************
            // ******************************************

            if (Manifest_Options.Text.Contains(",3301,")) // Search Manifest for Modcode (EOCM)
            {
                button24.BackColor = Color.Yellow;
                gv.EOCM = "YELO";
            }
            else
            {
                button24.BackColor = Color.LightGray;
                gv.EOCM = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",2901,")) // Search Manifest for Modcode (WCM - WIRELESS CHARGE MODULE)
            {
                button30.BackColor = Color.Yellow;
                gv.WCM = "YELO";
            }
            else
            {
                button30.BackColor = Color.LightGray;
                gv.WCM = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1101,")) // Search Manifest for Modcode (HEATED SEAT SW.)
            {
                button13.BackColor = Color.Yellow;
                gv.SEAT = "YELO";
            }
            else
            {
                button13.BackColor = Color.LightGray;
                gv.SEAT = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1302,")) // Search Manifest for Modcode (PEPS ANTENNA)
            {
                button18.BackColor = Color.Yellow;
                gv.PEPS = "YELO";
            }
            else
            {
                button18.BackColor = Color.LightGray;
                gv.PEPS = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",2701,")) // Search Manifest for Modcode (SIB - SHIFT INTERFACE BOARD)
            {
                button28.BackColor = Color.Yellow;
                gv.SIB = "YELO";
            }
            else
            {
                button28.BackColor = Color.LightGray;
                gv.SIB = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",4201,")) // Search Manifest for Modcode (TRAILER BRAKE SWITCH)
            {
                button20.BackColor = Color.Yellow;
                gv.TBS = "YELO";
            }
            else
            {
                button20.BackColor = Color.LightGray;
                gv.TBS = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",402,")) // Search Manifest for Modcode (MAIN CONSOLE LAMP)
            {
                button27.BackColor = Color.Yellow;
                gv.LAMP = "YELO";
            }
            else
            {
                button27.BackColor = Color.LightGray;
                gv.LAMP = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3501,")) // Search Manifest for Modcode (IMMOBILIZER ANTENNA)
            {
                button22.BackColor = Color.Yellow;
                gv.IMOB = "YELO";
            }
            else
            {
                button22.BackColor = Color.LightGray;
                gv.IMOB = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3101,") || Manifest_Options.Text.Contains(",3102,")) // Search Manifest for Modcode (HIGH VOLTAGE PO 3101)
            {
                button34.BackColor = Color.Yellow;
                gv.HVPO = "YELO";
            }
            else
            {
                button34.BackColor = Color.LightGray;
                gv.HVPO = "GRAY";
            }

            timer1.Stop();
            //Form3 frm3 = new Form3();
            gv.ConsoleTestMainForm.Show();
        }

        private void buttonMidlineManifest_Click(object sender, EventArgs e)
        {
            //  button31.BackColor = Color.Yellow;

            gv.Manifest = "MIDLINE MANUAL ENTRY";

            // CONSOLE MANIFEST - Midline
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13525890FT12,1502,13529874FW86,3002,135619101FT06,402,13592451FT45,1302,85117464FT09,1101,84638621GO2A,2701,84952174FW83,4201,13537143M08L,2901,";

            // ******************************************
            // ********* MOD codes for USB test *********
            // ******************************************

            if (Manifest_Options.Text.Contains(",4301,")) // Search Manifest for Modcode (Cupholder USB)
            {
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3002,")) // Search Manifest for Modcode (Body USB)
            {
                buttonBodyUSB.BackColor = Color.Yellow;
                buttonBodyResult.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
            }
            else
            {
                buttonBodyUSB.BackColor = Color.LightGray;
                buttonBodyResult.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1502,")) // Search Manifest for Modcode (Endcap USB)
            {
                buttonEndcapUSB.BackColor = Color.Yellow;
                buttonEndcapResult.BackColor = Color.Yellow;
                gv.ENDCAP_USB_SCAN = "YELO";
                gv.ENDCAP_USB_TEST = "YELO";
            }
            else
            {
                buttonEndcapUSB.BackColor = Color.LightGray;
                buttonEndcapResult.BackColor = Color.LightGray;
                gv.ENDCAP_USB_SCAN = "GRAY";
                gv.ENDCAP_USB_TEST = "GRAY";
            }

            // ******************************************
            // ********* All Other MOD codes ************
            // ******************************************

            if (Manifest_Options.Text.Contains(",3301,")) // Search Manifest for Modcode (EOCM)
            {
                button24.BackColor = Color.Yellow;
                gv.EOCM = "YELO";
            }
            else
            {
                button24.BackColor = Color.LightGray;
                gv.EOCM = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",2901,")) // Search Manifest for Modcode (WCM - WIRELESS CHARGE MODULE)
            {
                button30.BackColor = Color.Yellow;
                gv.WCM = "YELO";
            }
            else
            {
                button30.BackColor = Color.LightGray;
                gv.WCM = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1101,")) // Search Manifest for Modcode (HEATED SEAT SW.)
            {
                button13.BackColor = Color.Yellow;
                gv.SEAT = "YELO";
            }
            else
            {
                button13.BackColor = Color.LightGray;
                gv.SEAT = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1302,")) // Search Manifest for Modcode (PEPS ANTENNA)
            {
                button18.BackColor = Color.Yellow;
                gv.PEPS = "YELO";
            }
            else
            {
                button18.BackColor = Color.LightGray;
                gv.PEPS = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",2701,")) // Search Manifest for Modcode (SIB - SHIFT INTERFACE BOARD)
            {
                button28.BackColor = Color.Yellow;
                gv.SIB = "YELO";
            }
            else
            {
                button28.BackColor = Color.LightGray;
                gv.SIB = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",4201,")) // Search Manifest for Modcode (TRAILER BRAKE SWITCH)
            {
                button20.BackColor = Color.Yellow;
                gv.TBS = "YELO";
            }
            else
            {
                button20.BackColor = Color.LightGray;
                gv.TBS = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",402,")) // Search Manifest for Modcode (MAIN CONSOLE LAMP)
            {
                button27.BackColor = Color.Yellow;
                gv.LAMP = "YELO";
            }
            else
            {
                button27.BackColor = Color.LightGray;
                gv.LAMP = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3501,")) // Search Manifest for Modcode (IMMOBILIZER ANTENNA)
            {
                button22.BackColor = Color.Yellow;
                gv.IMOB = "YELO";
            }
            else
            {
                button22.BackColor = Color.LightGray;
                gv.IMOB = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3101,") || Manifest_Options.Text.Contains(",3102,")) // Search Manifest for Modcode (HIGH VOLTAGE PO 3101)
            {
                button7.BackColor = Color.Yellow;
                gv.HVPO = "YELO";
            }
            else
            {
                button7.BackColor = Color.LightGray;
                gv.HVPO = "GRAY";
            }

            timer1.Stop();
            //Form3 frm3 = new Form3();
            gv.ConsoleTestMainForm.Show();
        }

        private void buttonBaseManifest_Click(object sender, EventArgs e)
        {
            buttonBaseManifest.BackColor = Color.Yellow; // BASE SELECTED SO TURN BUTTON COLOR YELLOW

            // button31.BackColor = Color.Yellow; // PN MODULE PART NUMBER IS TESTED FOR BASE

            gv.Manifest = "BASE MANUAL ENTRY";

            // CONSOLE MANIFEST - Base
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,13529874FW86,3002,84638621GO2A,2701,135619101FT06,402,";

            // ******************************************
            // ********* MOD codes for USB test *********
            // ******************************************

            if (Manifest_Options.Text.Contains(",4301,")) // Search Manifest for Modcode (Cupholder USB)
            {
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3002,")) // Search Manifest for Modcode (Body USB)
            {
                buttonBodyUSB.BackColor = Color.Yellow;
                buttonBodyResult.BackColor = Color.Yellow;
                gv.BODY_USB_SCAN = "YELO";
                gv.BODY_USB_TEST = "YELO";
            }
            else
            {
                buttonBodyUSB.BackColor = Color.LightGray;
                buttonBodyResult.BackColor = Color.LightGray;
                gv.BODY_USB_SCAN = "GRAY";
                gv.BODY_USB_TEST = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1502,")) // Search Manifest for Modcode (Endcap USB)
            {
                buttonEndcapUSB.BackColor = Color.Yellow;
                buttonEndcapResult.BackColor = Color.Yellow;
                gv.ENDCAP_USB_SCAN = "YELO";
                gv.ENDCAP_USB_TEST = "YELO";
            }
            else
            {
                buttonEndcapUSB.BackColor = Color.LightGray;
                buttonEndcapResult.BackColor = Color.LightGray;
                gv.ENDCAP_USB_SCAN = "GRAY";
                gv.ENDCAP_USB_TEST = "GRAY";
            }

            // ******************************************
            // ********* All Other MOD codes ************
            // ******************************************

            if (Manifest_Options.Text.Contains(",3301,")) // Search Manifest for Modcode (EOCM)
            {
                button24.BackColor = Color.Yellow;
                gv.EOCM = "YELO";
            }
            else
            {
                button24.BackColor = Color.LightGray;
                gv.EOCM = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",2901,")) // Search Manifest for Modcode (WCM - WIRELESS CHARGE MODULE)
            {
                button30.BackColor = Color.Yellow;
                gv.WCM = "YELO";
            }
            else
            {
                button30.BackColor = Color.LightGray;
                gv.WCM = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1101,")) // Search Manifest for Modcode (HEATED SEAT SW.)
            {
                button13.BackColor = Color.Yellow;
                gv.SEAT = "YELO";
            }
            else
            {
                button13.BackColor = Color.LightGray;
                gv.SEAT = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",1302,")) // Search Manifest for Modcode (PEPS ANTENNA)
            {
                button18.BackColor = Color.Yellow;
                gv.PEPS = "YELO";
            }
            else
            {
                button18.BackColor = Color.LightGray;
                gv.PEPS = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",2701,")) // Search Manifest for Modcode (SIB - SHIFT INTERFACE BOARD)
            {
                button28.BackColor = Color.Yellow;
                gv.SIB = "YELO";
            }
            else
            {
                button28.BackColor = Color.LightGray;
                gv.SIB = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",4201,")) // Search Manifest for Modcode (TRAILER BRAKE SWITCH)
            {
                button20.BackColor = Color.Yellow;
                gv.TBS = "YELO";
            }
            else
            {
                button20.BackColor = Color.LightGray;
                gv.TBS = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",402,")) // Search Manifest for Modcode (MAIN CONSOLE LAMP)
            {
                button27.BackColor = Color.Yellow;
                gv.LAMP = "YELO";
            }
            else
            {
                button27.BackColor = Color.LightGray;
                gv.LAMP = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3501,")) // Search Manifest for Modcode (IMMOBILIZER ANTENNA)
            {
                button22.BackColor = Color.Yellow;
                gv.IMOB = "YELO";
            }
            else
            {
                button22.BackColor = Color.LightGray;
                gv.IMOB = "GRAY";
            }

            if (Manifest_Options.Text.Contains(",3101,") || Manifest_Options.Text.Contains(",3102,")) // Search Manifest for Modcode (HIGH VOLTAGE PO 3101)
            {
                button7.BackColor = Color.Yellow;
                gv.HVPO = "YELO";
            }
            else
            {
                button7.BackColor = Color.LightGray;
                gv.HVPO = "GRAY";
            }

            timer1.Stop();
            //Form3 frm3 = new Form3();
            gv.ConsoleTestMainForm.Show();
        }

        private void button32_Click(object sender, EventArgs e)  // FOR DEMO ONLY! START ANALOG TEST
        {
            timer1.Stop();
            //Form1 frm1 = new Form1();
            gv.DiagnosticForm.Show();
        }

        private void button33_Click(object sender, EventArgs e) // FOR DEMO SEND TEST RESULTS TO PLC
        {
            textBoxOperatorPrompts.Text = "";
            textBoxOperatorPrompts.Text += "REPORT TEST RESULTS TO PLC";

            //global_variables.WCM = "PASS";
            //global_variables.WCM_BASE_PN = textBoxWCM_BaseModelPartNumber8.Text;
            //global_variables.WCM_END_PN = textBoxWCM_EndModelPartNumber8.Text;
            //global_variables.WCM_BOOT_PN = textBoxWCM_BootSWID8.Text;
            //global_variables.WCM_ASWID_PN = textBoxWCM_AppSWID10.Text;
            // global_variables.WCM_ADATAID_PN = textBoxWCM_AppDataID10.Text;
            //global_variables.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
            //global_variables.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;

            // global_variables.SIB = "PASS";
            // global_variables.SIB_BASE_PN = textBoxSIB_BaseModelPartNumber8.Text;
            // global_variables.SIB_END_PN = textBoxSIB_EndModelPartNumber8.Text;
            //  global_variables.SIB_BOOT_PN = textBoxSIB_BootSWID8.Text;
            //  global_variables.SIB_ASWID_PN = textBoxSIB_AppSWID10.Text;
            //  global_variables.SIB_ADATAID_PN = textBoxSIB_AppDataID10.Text;
            //   global_variables.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
            //   global_variables.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;

            //   global_variables.EOCM = "PASS";
            //  global_variables.EOCM_BASE_PN = textBoxEOCM_BaseModelPartNumber8.Text;
            //  global_variables.EOCM_END_PN = textBoxEOCM_EndModelPartNumber8.Text;
            //  global_variables.EOCM_BOOT_PN = textBoxEOCM_BootSWID8.Text;
            //   global_variables.EOCM_ASWID_PN = textBoxEOCM_AppSWID10.Text;
            //   global_variables.EOCM_ADATAID_PN = textBoxEOCM_AppDataID10.Text;
            //   global_variables.PN_TIME_READ = TextBox_Time_of_PN_Read.Text;
            //   global_variables.PN_DATE_READ = TextBox_Date_of_PN_Read.Text;

            //   global_variables.LIN_SEAT_SW = "PASS";

            //   global_variables.LIN_TBS = "PASS";
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            byte[] data = new byte[] { 0, 0, 0, 0 };
            _ = AIOUSB.DIO_ReadAll(gv.diDIO, data);
            bool bConsole_PIP_55Way_Detected = ((data[2] & 0x02) == 0x02) ? true: false; // Console 55-way PIP Switch or Headliner 59-way PIP Switch

            //******************************************************************
            //*************  Check for operator to connect the 55-way harness
            //*******************************************************************

            if (bConsole_PIP_55Way_Detected) // Console_PIP_55Way has been detected
            {
                // ONE SHOT

                // textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "PIP Detected\n\r" + "\n\r" + "\n\r";

                if (textBoxOperatorPrompts.Text.Contains("Cycle Complete"))
                {
                    // DO NOTHING
                    //textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected\n\r" + "\n\r" + "\n\r";
                }
                else
                {
                    textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Cycle Complete\n\r" + "\n\r" + "\n\r";

                    // **************************************************************************************************************************
                    // ****************** Start the Console Test CYCLE COMPLETE Sequence *************************************************************
                    // **************************************************************************************************************************
                    //AIOUSB.DIO_Write1(diDIO, 11, 0); // Energize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                    //***************************************************************************************************************************

                    _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 1); // Deenergize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 1); // Denergize Sol #2   CONSOLE 55-way DRAW DOWN

                    // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 9, 1);  // Denergize SOL #1   CONSOLE 55-way LATCH

                    // textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Denergize Sol #1 & 2 \n\r" + "\n\r" + "\n\r";
                }

                //******************************************************************
                //*************  Check for operator to reconnect the 55-way harness
                //*******************************************************************

                //    AIOUSB.DIO_Write1(diDIO, 11, 0); // Reenergize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                //    AIOUSB.DIO_Write1(diDIO, 10, 0); // Renergize Sol #2   CONSOLE 55-way DRAW DOWN

                // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
                //     AIOUSB.DIO_Write1(diDIO, 9, 0);  // Renergize SOL #1   CONSOLE 55-way LATCH

                ///  textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected";
                //  textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Cycle Start";

                //timer1.Stop();
                ////Form3 frm3 = new Form3();
                //global_variables.frm3.Show();
            }
        }

        private void buttonCupholderUSB_Click(object sender, EventArgs e)
        {
            gv.Manifest = "MANUAL ENTRY"; // CUPHOLDER USB TEST

            if (buttonCupholderUSB.BackColor == Color.Yellow)
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
            }
        }

        private void buttonCupholderScan_Click(object sender, EventArgs e)
        {
            gv.Manifest = "MANUAL ENTRY";// CUPHOLDER USB SCAN

            if (buttonCupholder.BackColor == Color.Yellow)
            {
                buttonCupholderUSB.BackColor = Color.LightGray;
                buttonCupholder.BackColor = Color.LightGray;
                gv.CUPHOLDER_USB_SCAN = "GRAY";
                gv.CUPHOLDER_USB_TEST = "GRAY";
            }
            else
            {
                buttonCupholderUSB.BackColor = Color.Yellow;
                buttonCupholder.BackColor = Color.Yellow;
                gv.CUPHOLDER_USB_SCAN = "YELO";
                gv.CUPHOLDER_USB_TEST = "YELO";
            }
        }

        private void button7_Click(object sender, EventArgs e) // PN DEFAULT IS YELLOW
        {
            if (button7.BackColor == Color.Yellow)
            {
                button7.BackColor = Color.LightGray;
            }
            else
            {
                button7.BackColor = Color.Yellow;
            }
        }

        private void button34_Click(object sender, EventArgs e) // HVPO
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button34.BackColor == Color.Yellow)
            {
                button34.BackColor = Color.LightGray;
                gv.HVPO = "GRAY";
            }
            else
            {
                button34.BackColor = Color.Yellow;
                gv.HVPO = "YELO";
            }
        }

        private void buttonCancel_Click(object sender, EventArgs e) // CANCEL BUTTON PRESSED Blow-off 55-way
        {
            //************************************************************************
            //**************** Configure I/O for the main timer loop  ****************
            //************************************************************************
            byte[] data = new byte[] { 0, 0, 0, 0 };
            _ = AIOUSB.DIO_ReadAll(gv.diDIO, data);
            bool bConsole_55Way_PIP_Detected = ((data[2] & 0x02) == 0x02) ? true : false;// Console 55-way PIP Switch or Headliner 59-way PIP Switch

            if (bConsole_55Way_PIP_Detected) // Console_PIP_55Way has been detected
            {
                // ONE SHOT

                textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "PIP Detected\n\r" + "\n\r" + "\n\r";

                if (textBoxOperatorPrompts.Text.Contains("Cycle Complete"))
                {
                    // DO NOTHING
                    //textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected\n\r" + "\n\r" + "\n\r";
                }
                else
                {
                    textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Cycle Complete\n\r" + "\n\r" + "\n\r";

                    _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 1); // Deenergize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 1); // Denergize Sol #2   CONSOLE 55-way DRAW DOWN

                    // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 9, 1);  // Denergize SOL #1   CONSOLE 55-way LATCH
                }
            
                //******************************************************************
                //*************  Check for operator to reconnect the 55-way harness
                //*******************************************************************

                //    AIOUSB.DIO_Write1(diDIO, 11, 0); // Reenergize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                //    AIOUSB.DIO_Write1(diDIO, 10, 0); // Renergize Sol #2   CONSOLE 55-way DRAW DOWN

                // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
                //     AIOUSB.DIO_Write1(diDIO, 9, 0);  // Renergize SOL #1   CONSOLE 55-way LATCH

                ///  textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected";
                //  textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Cycle Start";

                //timer1.Stop();
                ////Form3 frm3 = new Form3();
                //global_variables.frm3.Show();
            }

            ////Form3 frm3 = new Form3();
            //global_variables.frm3.Show();
        }
    }
}