﻿using AIOUSBNet;  // namespace exposes AIOUSB Class interface
using System;
using System.Drawing;
using System.Threading;
using System.Windows.Forms;

// you must also add a reference to the AIOUSBNet.dll in the project
// The path should be C:\Windows\system32\AIOUSBNet.dll or the equivalent for your system

namespace Sample1
{
    public partial class HeadlinerConnectTestForm : Form
    {
        public HeadlinerConnectTestForm()
        {
            InitializeComponent();
        }

        private void buttonConnect55Way_Click(object sender, EventArgs e)    // CONNECT 55-WAY BUTTON PRESSED  .... CHECKS THE PIP SWITCHES WHICH CHANGES COLOR FROM YELLOW TO AQUAMARINE
        {
        }

        private void HeadlinerConnectTestForm_Load(object sender, EventArgs e)  // FORM LOAD ALSO CHECKS THE PIP SWITCHES WHICH STARTS THE DRAW DOWN SOLENOIDS
        {
            OperatorInstructions.Text = ""; // CLEAR SCREEN

            // CHECK FOR RETRY FAILED TEST
            if (gv.MIC.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "CHECK FOR OPEN LEFT MIC\n\r\n\r";
            }

            if (gv.CMIC.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "CHECK FOR OPEN RIGHT MIC\n\r\n\r";
            }

            if (gv.LSLAMP.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "MAKE SURE LEFT SUNSHADE LAMP IS ON\n\r\n\r";
            }

            if (gv.RSLAMP.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "MAKE SURE RIGHT SUNSHADE LAMP IS ON\n\r\n\r";
            }

            if (gv.R2LAMPC.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "CHECK FOR OPEN DOME LAMP\n\r\n\r";
            }

            if (gv.RETEST.Contains(""))
            {
                textBoxfrm4VIN.Text = gv.CSN;

                OperatorInstructions.Text = ""; // CLEAR SCREEN
                OperatorInstructions.Text = "<<< OPERATOR >>> \n\r\n\r\n\r";
                OperatorInstructions.Text += "OPEN L&R SUNSHADE LAMPS\n\r\n\r";
                OperatorInstructions.Text += "CONNECT 59-WAY OR 55-WAY \n\r\n\r";
                OperatorInstructions.Text += "CONNECT 16-WAY (X1 & X2) \n\r\n\r";
                textBoxRESULTS.Text += " \n\r\n\r";
                textBox2.Text = ".";

                //*************************************************************
                // ***** PREMIUM MANIFEST FOR RED RABBIT TEST NOT FROM THE PLC
                //****** MUST REMOVE REMARKS FOR PRODUCTION
                //************************************************************

                // ONE SHOT
                //              if (textBoxRESULTS.Text.Contains("Finished Read of PLC DB Manifest with Sharp7"))
                //              {
                // DO NOTHING

                //              }
                //              else
                //              {
                // *********************************************
                // *********** Read PLC DB Manifest with Sharp7
                // *********************************************

                //              int Rack = 0;
                //              int Slot = 0;
                //              int Good = 0;

                //              Client.ConnectTo("10.11.51.50", Rack, Slot);
                //              Client.Connect();

                //SetConnectionParams

                //              ComponentResult Result = new ComponentResult();
                //              byte[] Buffer = new byte[256];

                //              Client.DBRead(61, 0, 256, Buffer);
                //              string msg = System.Text.Encoding.ASCII.GetString(Buffer);

                //              textBoxRESULTS.Text += "\n";
                //              for (int iii = 0; iii < 256; ++iii)
                //              {
                //                  textBoxRESULTS.Text += Buffer[iii].ToString("x2") + ",";
                //              }
                //              textBoxRESULTS.Text += "\n";

                //              textBoxRESULTS.Text = textBoxRESULTS.Text + "Finished Read of PLC DB Manifest with Sharp7\n\r\n\r";

                // Extracts the fields and inserts them into the struct
                //  Result.SerialNumber = S7.GetCharsAt(Buffer, 0, 12);
                //  Result.TestResult = S7.GetIntAt(Buffer, 12);
                //  Result.LeakDetected = S7.GetRealAt(Buffer, 14);
                //  Result.TestDateTime = S7.GetDateTimeAt(Buffer, 18);

                //          }

                //*********************************************
                // ***** PREMIUM MANIFEST FOR RED RABBIT TEST
                //****** MUST REMARK OUT FOR PRODUCTION
                //********************************************

                // HEADLINER MANIFEST - Highline
                // textBoxRESULTS.Text = ""; // Clear Screen
                textBoxRESULTS.Text += "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84810967M38A,201,84793091FT29,301,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,84798058FW80,1801,";

                // PARSE OUT THE CSN #
                gv.CSN = textBoxRESULTS.Text.Substring(28, 13);
                textBoxfrm4VIN.Text = gv.CSN;

                // *******************************************************
                // ********* HEADLINER TEST MOD codes ********************
                // *******************************************************

                //// Search Manifest for Modcode <<<< 201 THROUGH 205 >>>> (Cell Phone MIC LEFT ??)
                gv.CMIC = (textBoxRESULTS.Text.Contains(",201,") || textBoxRESULTS.Text.Contains(",202,") || textBoxRESULTS.Text.Contains(",203,") 
                        || textBoxRESULTS.Text.Contains(",204,") || textBoxRESULTS.Text.Contains(",205,")) 
                        ? "YELO" : "GRAY";

                //Search Manifest for Modcode <<<< 301 through 307 >>>> (Other MIC RIGHT ??)
                gv.MIC = (textBoxRESULTS.Text.Contains(",301,") || textBoxRESULTS.Text.Contains(",302,") || textBoxRESULTS.Text.Contains(",303,") 
                       || textBoxRESULTS.Text.Contains(",304,") || textBoxRESULTS.Text.Contains(",305,") || textBoxRESULTS.Text.Contains(",306,") || textBoxRESULTS.Text.Contains(",307,"))
                       ? "YELO" : "GRAY";


                // Search Manifest for Modcode (Noise Cancel MIC)
                gv.ANCMIC = (textBoxRESULTS.Text.Contains(",1801,")) ? "YELO" : "GRAY";

                // Search Manifest for Modcode <<<< 501 TO 510 >>>>
                //
                // (DOME LAMP)
                //
                // WHICH IS WHICH ???????????
                //
                // LAMP_H = STOP LAMP
                // ECLAMP = EXTERIOR COURTESY LAMP
                // R2LAMPS = ROW 2 DOME LAMP SWITCH
                // R2LAMPS2 = ROW 2 DOME LAMP SWITCH 2
                // R2LAMPC = ROW 2 DOME LAMP CONTROL <<<< VALIDATED AS 501 THROUGH 510 *********************
                // R2LAMPC2 = ROW 2 DOME LAMP CONTROL2

                // HEADLINER LAMP
                gv.R2LAMPC = 
                    (   textBoxRESULTS.Text.Contains(",501,") || textBoxRESULTS.Text.Contains(",502,") || textBoxRESULTS.Text.Contains(",503,") 
                    || textBoxRESULTS.Text.Contains(",504,") || textBoxRESULTS.Text.Contains(",505,") || textBoxRESULTS.Text.Contains(",506,") 
                    || textBoxRESULTS.Text.Contains(",507,") || textBoxRESULTS.Text.Contains(",508,") || textBoxRESULTS.Text.Contains(",509,") 
                    || textBoxRESULTS.Text.Contains(",510,")
                   ) ? "YELO" : "GRAY";

                // Search Manifest for Modcode <<<< 801 TO 830 >>>> (LEFT SUNSHADE LAMP)
                gv.LSLAMP = (   textBoxRESULTS.Text.Contains(",501,") || textBoxRESULTS.Text.Contains(",502,") || textBoxRESULTS.Text.Contains(",503,") 
                    || textBoxRESULTS.Text.Contains(",504,") || textBoxRESULTS.Text.Contains(",505,") || textBoxRESULTS.Text.Contains(",506,") 
                    || textBoxRESULTS.Text.Contains(",507,") || textBoxRESULTS.Text.Contains(",508,") || textBoxRESULTS.Text.Contains(",509,") 
                    || textBoxRESULTS.Text.Contains(",510,") || textBoxRESULTS.Text.Contains(",511,") || textBoxRESULTS.Text.Contains(",512,") 
                    || textBoxRESULTS.Text.Contains(",513,") || textBoxRESULTS.Text.Contains(",514,") || textBoxRESULTS.Text.Contains(",515,") 
                    || textBoxRESULTS.Text.Contains(",516,") || textBoxRESULTS.Text.Contains(",517,") || textBoxRESULTS.Text.Contains(",518,") 
                    || textBoxRESULTS.Text.Contains(",519,") || textBoxRESULTS.Text.Contains(",520,") || textBoxRESULTS.Text.Contains(",521,") 
                    || textBoxRESULTS.Text.Contains(",522,") || textBoxRESULTS.Text.Contains(",523,") || textBoxRESULTS.Text.Contains(",524,") 
                    || textBoxRESULTS.Text.Contains(",525,") || textBoxRESULTS.Text.Contains(",526,") || textBoxRESULTS.Text.Contains(",527,") 
                    || textBoxRESULTS.Text.Contains(",528,") || textBoxRESULTS.Text.Contains(",529,") || textBoxRESULTS.Text.Contains(",530,")
                   ) ? "YELO" : "GRAY";

                // Search Manifest for Modcode <<<< 901 TO 930 >>>> (RIGHT SUNSHADE LAMP)
                gv.RSLAMP = (   textBoxRESULTS.Text.Contains(",901,") || textBoxRESULTS.Text.Contains(",902,") || textBoxRESULTS.Text.Contains(",903,") 
                    || textBoxRESULTS.Text.Contains(",904,") || textBoxRESULTS.Text.Contains(",905,") || textBoxRESULTS.Text.Contains(",906,") 
                    || textBoxRESULTS.Text.Contains(",907,") || textBoxRESULTS.Text.Contains(",908,") || textBoxRESULTS.Text.Contains(",909,") 
                    || textBoxRESULTS.Text.Contains(",910,") || textBoxRESULTS.Text.Contains(",911,") || textBoxRESULTS.Text.Contains(",912,") 
                    || textBoxRESULTS.Text.Contains(",913,") || textBoxRESULTS.Text.Contains(",914,") || textBoxRESULTS.Text.Contains(",915,") 
                    || textBoxRESULTS.Text.Contains(",916,") || textBoxRESULTS.Text.Contains(",917,") || textBoxRESULTS.Text.Contains(",918,") 
                    || textBoxRESULTS.Text.Contains(",919,") || textBoxRESULTS.Text.Contains(",920,") || textBoxRESULTS.Text.Contains(",921,") 
                    || textBoxRESULTS.Text.Contains(",922,") || textBoxRESULTS.Text.Contains(",923,") || textBoxRESULTS.Text.Contains(",924,") 
                    || textBoxRESULTS.Text.Contains(",925,") || textBoxRESULTS.Text.Contains(",926,") || textBoxRESULTS.Text.Contains(",927,") 
                    || textBoxRESULTS.Text.Contains(",928,") || textBoxRESULTS.Text.Contains(",929,") || textBoxRESULTS.Text.Contains(",930,")
                   ) ? "YELO" : "GRAY";

/*
                //textBox2.Text = "X "; // TAKE FOCUS OFF OF OPERATOR PROMPT TEXT BOX
                byte[] data = new byte[] { 0, 0, 0, 0 };

                _ = AIOUSB.DIO_ReadAll(gv.diDIO, data);

                bool bConsole55WayDetected = ((data[2] & 0x02) == 0x02);// Console 55-way PIP Switch or Headliner 59-way PIP Switch
                bool bHeadliner59WayDetected = bConsole55WayDetected;// Console 55-way PIP Switch or Headliner 59-way PIP Switch
                bool bHeadliner55WayDetected = ((data[2] & 0x04) == 0x04);// Headliner 55-way PIP Switch
                bool bHeadliner16WayX1Detected = ((data[2] & 0x08) == 0x08);// Headliner 16-way X1 PIP Switch
                bool bHeadliner16WayX2Detected = ((data[2] & 0x10) == 0x10);// Headliner 16-way X2 PIP Switch

                // Initialize all Outputs to the OFF State
                _ = AIOUSB.DIO_Write1(0, 6, 1);  // Deactivate TEST FAIL (Interlock)
                _ = AIOUSB.DIO_Write1(0, 7, 1);  // Deactivate TEST PASS (Interlock)
                _ = AIOUSB.DIO_Write1(0, 8, 1);  // Deactivate END OF CYCLE (Interlock)
                _ = AIOUSB.DIO_Write1(0, 9, 1);  // Turn OFF SOL #1   CONSOLE 55-way LATCH / HEADLINER LATCH BH#1
                _ = AIOUSB.DIO_Write1(0, 10, 1); // Turn OFF SOL #2   CONSOLE 55-way DRAW DOWN / HEADLINER LATCH BH#2
                _ = AIOUSB.DIO_Write1(0, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1
                _ = AIOUSB.DIO_Write1(0, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2
                _ = AIOUSB.DIO_Write1(0, 13, 1); // TURN OFF SOL #5   HEADLINER AIR EJECT BH #3
                _ = AIOUSB.DIO_Write1(0, 14, 1); // CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet

                if (bHeadliner59WayDetected) 
                {
                    labelPIPswitchHDL59A.BackColor = Color.Aquamarine;  // Operator Display Change 59-way PIPa switch indicator COLOR from Default YELLOW to AQUAMARINE
                    labelPIPswitchHDL59B.BackColor = Color.Aquamarine;  // Operator Display Change 59-way PIPb switch indicator COLOR from Default YELLOW to AQUAMARINE

                    _ = AIOUSB.DIO_Write1(0, 11, 0); // Energize Sol #3   HEADLINER DRAW DOWN BH #1 59-way
                    labelDrawDownHDL59.BackColor = Color.Aquamarine;  // Operator Display Change 59-way DrawDown indicator COLOR from Default YELLOW to AQUAMARINE
                }

                if (bHeadliner55WayDetected) 
                {
                    labelPIPswitchHDL55A.BackColor = Color.Aquamarine; // Operator Display Change 55-way PIPa switch indicator COLOR from Default YELLOW to AQUAMARINE
                    labelPIPswitchHDL55B.BackColor = Color.Aquamarine; // Operator Display Change 55-way PIPb switch indicator COLOR from Default YELLOW to AQUAMARINE

                    _ = AIOUSB.DIO_Write1(0, 12, 0); // Energize Sol #4   HEADLINER DRAW DOWN BH #2 55-way
                    labelDrawDownHDL55.BackColor = Color.Aquamarine; // Operator Display Change 55-way DrawDown indicator COLOR from Default YELLOW to AQUAMARINE
                }

                if (bHeadliner16WayX1Detected) 
                {
                    labelPIPswitchHDL16X1.BackColor = Color.Aquamarine; // Operator Display Change 16/16 - way X1 PIP switch indicator COLOR from Default YELLOW to AQUAMARINE
                }

                if (bHeadliner16WayX2Detected)
                {
                    labelPIPswitchHDL16X2.BackColor = Color.Aquamarine; // Operator Display Change 16/16 - way X2 PIP switch indicator COLOR from Default YELLOW to AQUAMARINE
                }
*/
            }

            timer1.Start();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            OperatorInstructions.Text = ""; // CLEAR SCREEN

            // CHECK FOR RETRY FAILED TEST
            if (gv.MIC.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "CHECK FOR OPEN LEFT MIC\n\r\n\r";
                textBoxRESULTS.Text += "CHECK FOR OPEN LEFT MIC\n\r\n\r";
            }

            if (gv.CMIC.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "CHECK FOR OPEN RIGHT MIC\n\r\n\r";
                textBoxRESULTS.Text += "CHECK FOR OPEN RIGHT MIC\n\r\n\r";
            }

            if (gv.LSLAMP.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "MAKE SURE LEFT SUNSHADE LAMP IS ON\n\r\n\r";
                textBoxRESULTS.Text += "MAKE SURE LEFT SUNSHADE LAMP IS ON\n\r\n\r";
            }

            if (gv.RSLAMP.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "MAKE SURE RIGHT SUNSHADE LAMP IS ON\n\r\n\r";
                textBoxRESULTS.Text += "MAKE SURE RIGHT SUNSHADE LAMP IS ON\n\r\n\r";
            }

            if (gv.R2LAMPC.Contains("FAIL")) // RETURN TO PROMPT OPERATOR TO CHECK CONNECTION
            {
                gv.RETEST = "YES";
                OperatorInstructions.Text += "CHECK FOR OPEN DOME LAMP\n\r\n\r";
                textBoxRESULTS.Text += "CHECK FOR OPEN DOME LAMP\n\r\n\r";
            }

            if (gv.RETEST.Contains(""))
            {
                // ONE SHOT
                if (textBoxRESULTS.Text.Contains("CONNECT 16-WAY (X1 & X2)"))
                {
                    textBoxRESULTS.Text += " \n\r\n\r";
                    textBox2.Text = "";
                }
                else
                {
                    OperatorInstructions.Text = ""; // CLEAR SCREEN
                    OperatorInstructions.Text = "<<< OPERATOR >>> \n\r\n\r\n\r";
                    OperatorInstructions.Text += "OPEN L&R SUNSHADE LAMPS\n\r\n\r";
                    OperatorInstructions.Text += "CONNECT 59-WAY OR 55-WAY \n\r\n\r";
                    OperatorInstructions.Text += "CONNECT 16-WAY (X1 & X2) \n\r\n\r";
                    textBoxRESULTS.Text += "refreshed the operator prompt message \n\r\n\r";
                }

                byte[] data = new byte[] { 0, 0, 0, 0 };

                _ = AIOUSB.DIO_ReadAll(gv.diDIO, data);

                bool bConsole55WayDetected = ((data[2] & 0x02) == 0x02);// Console 55-way PIP Switch or Headliner 59-way PIP Switch
                bool bHeadliner59WayDetected = bConsole55WayDetected;// Console 55-way PIP Switch or Headliner 59-way PIP Switch
                bool bHeadliner55WayDetected = ((data[2] & 0x04) == 0x04);// Headliner 55-way PIP Switch
                bool bHeadliner16WayX1Detected = ((data[2] & 0x08) == 0x08);// Headliner 16-way X1 PIP Switch
                bool bHeadliner16WayX2Detected = ((data[2] & 0x10) == 0x10);// Headliner 16-way X2 PIP Switch

                if (gv.J2HDebugMode) // debugging mode only!!! -- J2H DEBUG 
                {
                    bConsole55WayDetected = true;
                    bHeadliner59WayDetected = true;
                    bHeadliner55WayDetected = true;
                    bHeadliner16WayX1Detected = true;
                    bHeadliner16WayX2Detected = true;
                }

                if (bHeadliner59WayDetected) 
                {
                    // ONE SHOT
                    if (textBoxRESULTS.Text.Contains("59-Way Connected"))
                    {
                        // DO NOTHING
                    }
                    else
                    {
                        labelPIPswitchHDL59A.BackColor = Color.Aquamarine;  // Operator Display Change 59-way PIPa switch indicator COLOR from Default YELLOW to AQUAMARINE
                        labelPIPswitchHDL59B.BackColor = Color.Aquamarine;  // Operator Display Change 59-way PIPb switch indicator COLOR from Default YELLOW to AQUAMARINE

                        _ = AIOUSB.DIO_Write1(0, 11, 0); // Energize Sol #3   HEADLINER DRAW DOWN BH #1 59-way
                        labelDrawDownHDL59.BackColor = Color.Aquamarine;  // Operator Display Change 59-way DrawDown indicator COLOR from Default YELLOW to AQUAMARINE

                        _ = AIOUSB.DIO_Write1(0, 9, 0);  // Turn ON SOL #1 HEADLINER LATCH BH#1 59-WAY
                        labelLatchHDL59A.BackColor = Color.Aquamarine;  //
                        labelLatchHDL59B.BackColor = Color.Aquamarine;  //
                        buttonConnect_59_Way.BackColor = Color.Aquamarine;  //

                        textBoxRESULTS.Text += "59-Way PIP switches detected\n\r\n\r";
                        textBoxRESULTS.Text += "59-Way Drawdown Solenoid Energized\n\r\n\r";
                        textBoxRESULTS.Text += "59-Way Latch Solenoid Energized\n\r\n\r";
                        textBoxRESULTS.Text += "59-Way Connected\n\r\n\r";
                    }
                }

                if (bHeadliner55WayDetected) 
                {
                    // ONE SHOT
                    if (textBoxRESULTS.Text.Contains("55-Way Connected"))
                    {
                        // DO NOTHING
                    }
                    else
                    {
                        labelPIPswitchHDL55A.BackColor = Color.Aquamarine; // Operator Display Change 55-way PIPa switch indicator COLOR from Default YELLOW to AQUAMARINE
                        labelPIPswitchHDL55B.BackColor = Color.Aquamarine; // Operator Display Change 55-way PIPb switch indicator COLOR from Default YELLOW to AQUAMARINE

                        _ = AIOUSB.DIO_Write1(0, 12, 0); // Energize Sol #4   HEADLINER DRAW DOWN BH #2 55-way
                        labelDrawDownHDL55.BackColor = Color.Aquamarine; // Operator Display Change 55-way DrawDown indicator COLOR from Default YELLOW to AQUAMARINE

                        _ = AIOUSB.DIO_Write1(0, 10, 0); // Turn ON SOL #2 HEADLINER LATCH BH #2 55-WAY
                        labelLatchHDL55.BackColor = Color.Aquamarine; //
                        buttonConnect_55_Way.BackColor = Color.Aquamarine; //

                        textBoxRESULTS.Text += "55-Way PIP switches detected\n\r\n\r";
                        textBoxRESULTS.Text += "55-Way Drawdown Solenoid Energized\n\r\n\r";
                        textBoxRESULTS.Text += "55-Way Latch Solenoid Energized\n\r\n\r";
                        textBoxRESULTS.Text += "55-Way Connected\n\r\n\r";
                    }
                }

                if (bHeadliner16WayX1Detected) 
                {
                    // ONE SHOT
                    if (textBoxRESULTS.Text.Contains("16/16-Way (X1) PIP switch detected"))
                    {
                        // Do nothing
                    }
                    else
                    {
                        labelPIPswitchHDL16X1.BackColor = Color.Aquamarine; // Operator Display Change 16/16 - way X1 PIP switch indicator COLOR from Default YELLOW to AQUAMARINE
                        Label_16_16_X1.BackColor = Color.Aquamarine; //
                        textBoxRESULTS.Text += "16/16-Way (X1) PIP switch detected\n\r\n\r";
                    }
                }

                if (bHeadliner16WayX2Detected) 
                {
                    // ONE SHOT
                    if (textBoxRESULTS.Text.Contains("16/16-Way (X2) PIP switch detected"))
                    {
                        // Do nothing
                    }
                    else
                    {
                        labelPIPswitchHDL16X2.BackColor = Color.Aquamarine; // Operator Display Change 16/16 - way X2 PIP switch indicator COLOR from Default YELLOW to AQUAMARINE
                        Label_16_16_X2.BackColor = Color.Aquamarine; //
                        textBoxRESULTS.Text += "16/16-Way (X2) PIP switch detected\n\r\n\r";
                    }
                }

                if (textBoxRESULTS.Text.Contains("16/16-Way (X2) PIP switch detected"))
                {
                    if (textBoxRESULTS.Text.Contains("16/16-Way (X1) PIP switch detected"))
                    {
                        // ONE SHOT
                        if (textBoxRESULTS.Text.Contains("16/16-Way (X1 & X2) Connected"))
                        {
                            // Do nothing
                        }
                        else
                        {
                            buttonConnect_16_16_way.BackColor = Color.Aquamarine; //
                            textBoxRESULTS.Text += "16/16-Way (X1 & X2) Connected\n\r\n\r";
                        }
                    }
                }

                // TEST FOR MANUAL RELEASE BUTTON PRESSED ON 59 WAY

                if (bHeadliner59WayDetected) 
                {
                    // DO NOTHING
                }
                else  // MANUAL RELEASE PRESSED ON 59-WAY ?
                {
                    if (textBoxRESULTS.Text.Contains("59-Way Connected"))
                    {
                        // RELEASE BOTH 59-WAY AND 16/16-WAY UNLATCH AND BLOW OFF SINCE IT HAS NO PUSH BUTTON
                        _ = AIOUSB.DIO_Write1(0, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1 59-WAY
                        _ = AIOUSB.DIO_Write1(0, 9, 1);  // Turn OFF SOL #1   HEADLINER LATCH BH #1 59-WAY
                        _ = AIOUSB.DIO_Write1(0, 13, 0); // TURN ON SOL #5   HEADLINER AIR EJECT BH #3 16/16-WAY
                    }
                }

                // TEST FOR MANUAL RELEASE BUTTON PRESSED ON 55 WAY

                if (bHeadliner55WayDetected)
                {
                    // DO NOTHING
                }
                else  // MANUAL RELEASE PRESSED ON 55-WAY ?
                {
                    if (textBoxRESULTS.Text.Contains("55-Way Connected"))
                    {
                        // RELEASE BOTH 55-WAY AND 16/16-WAY UNLATCH AND BLOW OFF SINCE IT HAS NO PUSH BUTTON
                        _ = AIOUSB.DIO_Write1(0, 10, 1); // Turn OFF SOL #2   HEADLINER LATCH BH#2 55-WAY
                        _ = AIOUSB.DIO_Write1(0, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2 55-WAY
                        _ = AIOUSB.DIO_Write1(0, 13, 0); // TURN ON SOL #5   HEADLINER AIR EJECT BH #3 16/16-WAY
                    }
                }

                //***********************************************************************************************
                //********* Read Module Part Numbers *************************************************************
                //************************************************************************************************
                // Shell Command to Launch Vehicle Spy ***********************************************************
                //************************************************************************************************
                // TCPIP TEXT COMMAND APP TO VEHICLE SPY TO START VEHICLE SPY PART NUMBER READ TEST BLOCK ROUTINES
                // ***********************************************************************************************

                // *****************************************************
                //********* Switch Form to Start Analog Test ***********
                //******************************************************

                if (bHeadliner59WayDetected || bHeadliner55WayDetected) 
                {
                    if (bHeadliner16WayX1Detected) 
                    {
                        if (bHeadliner16WayX2Detected) 
                        {
                            if ((textBoxRESULTS.Text.Contains("59-Way Connected") || (textBoxRESULTS.Text.Contains("55-Way Connected"))))
                            {
                                if (textBoxRESULTS.Text.Contains("16/16-Way (X1 & X2) Connected"))
                                {
                                    if (gv.MIC.Contains("PASS") || gv.CMIC.Contains("PASS") || gv.LSLAMP.Contains("PASS") || gv.RSLAMP.Contains("PASS") || gv.R2LAMPC.Contains("PASS"))
                                    {
                                        //DO NOTHING WAIT FOR OPERATOR TO REPAIR OR ABORT
                                    }
                                    else
                                    {
                                        Console.WriteLine("Headliner Testing Completed");
                                        timer1.Stop();

                                        // Wait 20 Seconds
                                        for (int i = 0; i < 20; i++)
                                        {
                                            Application.DoEvents();
                                            Thread.Sleep(100); 
                                        }

                                        //Form1 frm1 = new Form1();
                                        gv.HeadlinerTestResultsOptionsForm.Show();
                                    }
                                }
                            }
                        }
                    }
                }
            }
            else  // RETEST FAILED STUFF HERE ******************************************************************
            {
                Console.WriteLine("RETEST REACHED");
                timer1.Stop();
                Thread.Sleep(5000); // Wait 5 Seconds
                timer1.Start();

                OperatorInstructions.Text = ""; // CLEAR SCREEN
                OperatorInstructions.Text = "<<< OPERATOR >>> \n\r\n\r\n\r";
                OperatorInstructions.Text = "<<< RETEST >>> \n\r\n\r\n\r";
            }
        }

        private void label6_Click(object sender, EventArgs e)
        {
            Console.WriteLine("label6 clicked");
            // Initialize all Outputs to the OFF State

            _ = AIOUSB.DIO_Write1(0, 9, 1);  // Turn OFF SOL #1   CONSOLE 55-way LATCH / HEADLINER LATCH BH#1
            _ = AIOUSB.DIO_Write1(0, 10, 1); // Turn OFF SOL #2   CONSOLE 55-way DRAW DOWN / HEADLINER LATCH BH#2 59-WAY
            _ = AIOUSB.DIO_Write1(0, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1 59-WAY
            _ = AIOUSB.DIO_Write1(0, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2 55-WAY
            _ = AIOUSB.DIO_Write1(0, 13, 1); // TURN OFF SOL #5   HEADLINER AIR EJECT BH #3 16/16-WAY

            _ = AIOUSB.DIO_Write1(0, 9, 1);  // Turn OFF SOL #1   CONSOLE 55-way LATCH / HEADLINER LATCH BH#1
            _ = AIOUSB.DIO_Write1(0, 10, 1); // Turn OFF SOL #2   CONSOLE 55-way DRAW DOWN / HEADLINER LATCH BH#2
            _ = AIOUSB.DIO_Write1(0, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1
            _ = AIOUSB.DIO_Write1(0, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2
            _ = AIOUSB.DIO_Write1(0, 13, 1); // TURN OFF SOL #5   HEADLINER AIR EJECT BH #3

            _ = AIOUSB.DIO_Write1(0, 9, 1);  // Turn OFF SOL #1   CONSOLE 55-way LATCH / HEADLINER LATCH BH#1
            _ = AIOUSB.DIO_Write1(0, 10, 1); // Turn OFF SOL #2   CONSOLE 55-way DRAW DOWN / HEADLINER LATCH BH#2
            _ = AIOUSB.DIO_Write1(0, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1
            _ = AIOUSB.DIO_Write1(0, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2
            _ = AIOUSB.DIO_Write1(0, 13, 1); // TURN OFF SOL #5   HEADLINER AIR EJECT BH #3
        }

        private void ButtonExit_Click(object sender, EventArgs e)
        {
            Console.WriteLine("ButtonExit clicked");
            gv.bCloseProgram = true; // TODO: only set to true if developer means it!!
            if (gv.VSpy3ProcessHandle != null)
                _ = gv.VSpy3ProcessHandle.CloseMainWindow();
            Close();
        }

        private void ButtonAbortTest_Click(object sender, EventArgs e)
        {
            Console.WriteLine("ButtonAbortTest clicked");
            timer1.Stop();
            gv.HeadlinerTestResultsOptionsForm.Show();
        }
    }
}