﻿using AIOUSBNet;  // namespace exposes AIOUSB Class interface
using System;
using System.Drawing;
using System.Windows.Forms;

namespace Sample1
{
    public partial class HeadlinerTestResultsOptionsForm : Form
    {
        public HeadlinerTestResultsOptionsForm()
        {
            InitializeComponent();
        }

        private void buttonBCMLIN5_Click(object sender, EventArgs e)
        {
            if (buttonBCMLIN5.BackColor == Color.Yellow)
            {
                buttonBCMLIN5.BackColor = Color.LightGray;
            }
            else
            {
                buttonBCMLIN5.BackColor = Color.Yellow;
            }
        }

        private void HeadlinerTestResultsOptionsForm_Load(object sender, EventArgs e)
        {
            // Display Software Version
            labelSoftware_Version.Text = gv.SOFTWARE_VERSION;

            // CONSOLE MANIFEST - Highline (default)
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84810967M38A,201,84793091FT29,301,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,84798058FW80,1801,";

            // PARSE OUT THE CSN #
            gv.CSN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.CSN;

            // **************************************************
            // **** CHECK GLOBAL VARIABLES FOR TEST RESULTS *****
            //***************************************************

            if (gv.CMIC.Contains("PASS"))
            {
                button13.BackColor = Color.Aquamarine; // CMIC - PASS
            }
            else
            {
                if (gv.CMIC.Contains("YELO") || gv.CMIC.Contains("FAIL"))
                {
                    button13.BackColor = Color.Orange; // CMIC - FAIL
                    gv.CMIC = "FAIL";
                }
            }

            if (gv.MIC.Contains("PASS"))
            {
                button28.BackColor = Color.Aquamarine; // MIC - PASS
            }
            else
            {
                if (gv.MIC.Contains("YELO") || (gv.MIC.Contains("FAIL"))
                {
                    button28.BackColor = Color.Orange; // MIC - FAIL
                    gv.MIC = "FAIL";
                }
            }

            if (gv.ANCMIC.Contains("PASS"))
            {
                button5.BackColor = Color.Aquamarine; // ANCMIC - PASS
                Console.WriteLine("Button5 PASS");
            }
            else
            {
                if (gv.ANCMIC.Contains("YELO") || (gv.ANCMIC.Contains("FAIL")))
                {
                    button5.BackColor = Color.Orange; // ANCMIC - FAIL
                    gv.ANCMIC = "FAIL";
                }
            }

            if (gv.LAMP_H.Contains("PASS"))
            {
                button27.BackColor = Color.Aquamarine; // LAMP_H - PASS
            }
            else
            {
                if (gv.LAMP_H.Contains("YELO") || (gv.LAMP_H.Contains("FAIL")))
                {
                    button27.BackColor = Color.Orange; // LAMP_H - FAIL
                    gv.LAMP_H = "FAIL";
                }
            }

            if (gv.ECLAMP.Contains("PASS"))
            {
                button30.BackColor = Color.Aquamarine; // ECLAMP - PASS
            }
            else
            {
                if (gv.ECLAMP.Contains("YELO") || (gv.ECLAMP.Contains("FAIL")))
                {
                    button30.BackColor = Color.Orange; // ECLAMP - FAIL
                    gv.ECLAMP = "FAIL";
                }
            }

            if (gv.BCM.Contains("PASS"))
            {
                buttonBCMLIN5.BackColor = Color.Aquamarine; // BCM - PASS
            }
            else
            {
                if (gv.BCM.Contains("YELO") || (gv.BCM.Contains("FAIL")))
                {
                    buttonBCMLIN5.BackColor = Color.Orange; // BCM - FAIL
                    gv.BCM = "FAIL";
                }
            }

            if (gv.MIRROR.Contains("PASS"))
            {
                button20.BackColor = Color.Aquamarine; // MIRROR - PASS
            }
            else
            {
                if (gv.MIRROR.Contains("YELO") || gv.MIRROR.Contains("FAIL")))
                {
                    button20.BackColor = Color.Orange; // MIRROR - FAIL
                    gv.MIRROR = "FAIL";
                }
            }

            if (gv.R2LAMPS.Contains("PASS"))
            {
                button22.BackColor = Color.Aquamarine; // R2LAMPS - PASS
            }
            else
            {
                if (gv.R2LAMPS.Contains("YELO") || (gv.R2LAMPS.Contains("FAIL")))
                {
                    button22.BackColor = Color.Orange; // R2LAMPS - FAIL
                    gv.R2LAMPS = "FAIL";
                }
            }

            if (gv.R2LAMPS2_H.Contains("PASS"))
            {
                button24.BackColor = Color.Aquamarine; // R2LAMPS2_H - PASS
            }
            else
            {
                if (gv.R2LAMPS2_H.Contains("YELO") || (gv.R2LAMPS2_H.Contains("FAIL")))
                {
                    button24.BackColor = Color.Orange; // R2LAMPS2_H - FAIL
                    gv.R2LAMPS2_H = "FAIL";
                }
            }

            if (gv.LSLAMP.Contains("PASS"))
            {
                button7.BackColor = Color.Aquamarine; // LSLAMP - PASS
            }
            else
            {
                if (gv.LSLAMP.Contains("YELO") || (gv.LSLAMP.Contains("FAIL")))
                {
                    button7.BackColor = Color.Orange; // LSLAMP - FAIL
                    gv.LSLAMP = "FAIL";
                }
            }

            if (gv.RSLAMP.Contains("PASS"))
            {
                button43.BackColor = Color.Aquamarine; // RSLAMP - PASS
            }
            else
            {
                if (gv.RSLAMP.Contains("YELO") || (gv.RSLAMP.Contains("FAIL")))
                {
                    button43.BackColor = Color.Orange; // RSLAMP - FAIL
                    gv.RSLAMP = "FAIL";
                }
            }

            if (gv.R2LAMPC.Contains("PASS"))
            {
                button31.BackColor = Color.Aquamarine; // R2LAMPC - PASS
            }
            else
            {
                if (gv.R2LAMPC.Contains("YELO") || (gv.R2LAMPC.Contains("FAIL")))
                {
                    button31.BackColor = Color.Orange; // R2LAMPC - FAIL
                    gv.R2LAMPC = "FAIL";
                }
            }

            if (gv.R2LAMPS2.Contains("PASS"))
            {
                button33.BackColor = Color.Aquamarine; // R2LAMPS2 - PASS
            }
            else
            {
                if (gv.R2LAMPS2.Contains("YELO") || (gv.R2LAMPS2.Contains("FAIL")))
                {
                    button33.BackColor = Color.Orange; // R2LAMPS2 - FAIL
                    gv.R2LAMPS2 = "FAIL";
                }
            }

            timer1.Start();
        }

        private void buttonOkay_Click(object sender, EventArgs e)
        {
            timer1.Stop();
            if (gv.HeadlinerConnectTestForm != null)
            {
                gv.HeadlinerConnectTestForm.Close();
            }
        }

        private void button13_Click(object sender, EventArgs e)// CMIC
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button13.BackColor == Color.Yellow)
            {
                button13.BackColor = Color.LightGray;
                gv.CMIC = "GRAY";
            }
            else
            {
                button13.BackColor = Color.Yellow;
                gv.CMIC = "YELO";
            }
        }

        private void button28_Click(object sender, EventArgs e)// MIC
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button28.BackColor == Color.Yellow)
            {
                button28.BackColor = Color.LightGray;
                gv.MIC = "GRAY";
            }
            else
            {
                button28.BackColor = Color.Yellow;
                gv.MIC = "YELO";
            }
        }

        private void button5_Click(object sender, EventArgs e)//ANCMIC
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button5.BackColor == Color.Yellow)
            {
                button5.BackColor = Color.LightGray;
                gv.ANCMIC = "GRAY";
            }
            else
            {
                button5.BackColor = Color.Yellow;
                gv.ANCMIC = "YELO";
            }
        }

        private void button27_Click(object sender, EventArgs e)// LAMP_H
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button27.BackColor == Color.Yellow)
            {
                button27.BackColor = Color.LightGray;
                gv.LAMP_H = "GRAY";
            }
            else
            {
                button27.BackColor = Color.Yellow;
                gv.LAMP_H = "YELO";
            }
        }

        private void button30_Click(object sender, EventArgs e)// ECLAMP
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button30.BackColor == Color.Yellow)
            {
                button30.BackColor = Color.LightGray;
                gv.ECLAMP = "GRAY";
            }
            else
            {
                button30.BackColor = Color.Yellow;
                gv.ECLAMP = "YELO";
            }
        }

        private void button20_Click(object sender, EventArgs e)//MIRROR
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button20.BackColor == Color.Yellow)
            {
                button20.BackColor = Color.LightGray;
                gv.MIRROR = "GRAY";
            }
            else
            {
                button20.BackColor = Color.Yellow;
                gv.MIRROR = "YELO";
            }
        }

        private void button22_Click(object sender, EventArgs e)// R2LAMPS
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button22.BackColor == Color.Yellow)
            {
                button22.BackColor = Color.LightGray;
                gv.R2LAMPS = "GRAY";
            }
            else
            {
                button22.BackColor = Color.Yellow;
                gv.R2LAMPS = "YELO";
            }
        }

        private void button24_Click(object sender, EventArgs e)// R2LAMPS2_H
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button24.BackColor == Color.Yellow)
            {
                button24.BackColor = Color.LightGray;
                gv.R2LAMPS2_H = "GRAY";
            }
            else
            {
                button24.BackColor = Color.Yellow;
                gv.R2LAMPS2_H = "YELO";
            }
        }

        private void button7_Click(object sender, EventArgs e)// LSLAMP
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button7.BackColor == Color.Yellow)
            {
                button7.BackColor = Color.LightGray;
                gv.LSLAMP = "GRAY";
            }
            else
            {
                button7.BackColor = Color.Yellow;
                gv.LSLAMP = "YELO";
            }
        }

        private void button43_Click(object sender, EventArgs e)// RSLAMP
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button43.BackColor == Color.Yellow)
            {
                button43.BackColor = Color.LightGray;
                gv.RSLAMP = "GRAY";
            }
            else
            {
                button43.BackColor = Color.Yellow;
                gv.RSLAMP = "YELO";
            }
        }

        private void button31_Click(object sender, EventArgs e) // R2LAMPC
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button31.BackColor == Color.Yellow)
            {
                button31.BackColor = Color.LightGray;
                gv.R2LAMPC = "GRAY";
            }
            else
            {
                button31.BackColor = Color.Yellow;
                gv.R2LAMPC = "YELO";
            }
        }

        private void button33_Click(object sender, EventArgs e)// R2LAMPS2
        {
            gv.Manifest = "MANUAL ENTRY";

            if (button33.BackColor == Color.Yellow)
            {
                button33.BackColor = Color.LightGray;
                gv.R2LAMPS2 = "GRAY";
            }
            else
            {
                button33.BackColor = Color.Yellow;
                gv.R2LAMPS2 = "YELO";
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            gv.Manifest = "MANUAL ENTRY";

            buttonBCMLIN5.BackColor = Color.LightGray;
            button13.BackColor = Color.LightGray;
            button28.BackColor = Color.LightGray;
            button5.BackColor = Color.LightGray;
            button27.BackColor = Color.LightGray;
            button30.BackColor = Color.LightGray;
            button20.BackColor = Color.LightGray;
            button22.BackColor = Color.LightGray;
            button24.BackColor = Color.LightGray;
            button7.BackColor = Color.LightGray;
            button43.BackColor = Color.LightGray;
            button31.BackColor = Color.LightGray;
            button33.BackColor = Color.LightGray;
        }

        private void SetupTestingPerManifest()
        {

            // ******************************************
            // ********* MOD codes per Option ***********
            // ******************************************

            if (Manifest_Options.Text.Contains(",201,")) // Search Manifest for Modcode <<<< 201 THROUGH 205 >>>> (Cell Phone MIC LEFT ??) ???????????????????
            {
                button13.BackColor = Color.Yellow;
            }
            else
            {
                button13.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",301,")) // Search Manifest for Modcode <<<< 301 through 307 >>>> (Other MIC RIGHT ??) ??????????????????????
            {
                button28.BackColor = Color.Yellow;
            }
            else
            {
                button28.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",1801,")) // Search Manifest for Modcode (Noise Cancel MIC)
            {
                button5.BackColor = Color.Yellow;
            }
            else
            {
                button5.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",1801,")) // Search Manifest for Modcode (Noise Cancel MIC)
            {
                button5.BackColor = Color.Yellow;
            }
            else
            {
                button5.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",601,")) // Search Manifest for Modcode (STOP LAMP) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                button27.BackColor = Color.Yellow;
            }
            else
            {
                button27.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",602,")) // Search Manifest for Modcode (EXT. COURTESY LAMP) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                button30.BackColor = Color.Yellow;
            }
            else
            {
                button30.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",603,")) // Search Manifest for Modcode (BCM LIN 5) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                buttonBCMLIN5.BackColor = Color.Yellow;
            }
            else
            {
                buttonBCMLIN5.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",604,")) // Search Manifest for Modcode (DAY NIGHT MIRROR) (HARNESS MOD CODE 601-630 ???) ???????????????????????
            {
                button20.BackColor = Color.Yellow;
            }
            else
            {
                button20.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP SWITCH) ??????????????
            {
                button22.BackColor = Color.Yellow;
            }
            else
            {
                button22.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP SWITCH 2) ??????????????
            {
                button24.BackColor = Color.Yellow;
            }
            else
            {
                button24.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",801,")) // Search Manifest for Modcode <<<< 801 TO 830 >>>> (LEFT SUNSHADE LAMP) ??????????????
            {
                button7.BackColor = Color.Yellow;
            }
            else
            {
                button7.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",901,")) // Search Manifest for Modcode <<<< 901 TO 930 >>>> (RIGHT SUNSHADE LAMP) ??????????????
            {
                button43.BackColor = Color.Yellow;
            }
            else
            {
                button43.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP CONTROL) ??????????????
            {
                button31.BackColor = Color.Yellow;
            }
            else
            {
                button31.BackColor = Color.LightGray;
            }

            if (Manifest_Options.Text.Contains(",501,")) // Search Manifest for Modcode <<<< 501 TO 510 >>>> (R2 DOME LAMP CONTROL 2) ??????????????
            {
                button33.BackColor = Color.Yellow;
            }
            else
            {
                button33.BackColor = Color.LightGray;
            }
        }

        private void buttonHighlineManifest_Click(object sender, EventArgs e)
        {
            // HEADLINER MANIFEST - Highline
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84810967M38A,201,84793091FT29,301,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,84798058FW80,1801,";

            // PARSE OUT THE CSN #
            gv.VIN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.VIN;
            SetupTestingPerManifest();
        }

        private void buttonMidlineManifest_Click(object sender, EventArgs e)
        {
            // CONSOLE MANIFEST - Midline
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,84874628FT28,501,84660808A28B,901,????????????,601,????????????,602,????????????,603,????????????,604,85116495M40P,601,846608188A28A,801,";

            // PARSE OUT THE CSN #
            gv.VIN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.VIN;
            SetupTestingPerManifest();
        }


        private void buttonBaselineManifest_Click(object sender, EventArgs e)
        {
            // CONSOLE MANIFEST - Baseline (default)
            Manifest_Options.Text = ""; // Clear Screen
            Manifest_Options.Text = "0000000355149,103xxxxxxxxxx,0000004364960,????????????,601,????????????,602,????????????,603,";

            // PARSE OUT THE CSN #
            gv.VIN = Manifest_Options.Text.Substring(28, 13);
            textBoxfrm5VIN.Text = gv.VIN;
            SetupTestingPerManifest();
        }


        private void timer1_Tick(object sender, EventArgs e)
        {
            //if (global_variables.ANCMIC.Contains("PASS")) button5.BackColor = Color.Aquamarine;
            if (gv.ANCMIC.Contains("FAIL")) button5.BackColor = Color.Orange;
            //if (global_variables.CMIC.Contains("PASS")) button13.BackColor = Color.Aquamarine;
            if (gv.CMIC.Contains("FAIL")) button13.BackColor = Color.Orange;

            //************************************************************************
            //**************** Configure I/O for the main timer loop  ****************
            //************************************************************************


            byte input1; // Console 55-way PIP Switch or Headliner 59-way PIP Switch
            byte input2; // Headliner 55-way PIP Switch
            byte input3; // Headliner 16-way X1 PIP Switch
            byte input4; // Headliner 16-way X2 PIP Switch
            byte input5; // Console 12Vdc Power Outlet Test on RFID card reader Block
            byte input6; // Console 5V USB Charge Test on RFID card reader Block


            byte[] data = new byte[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

            _ = AIOUSB.DIO_ReadAll(gv.diDIO, data);

            if ((data[2] & 0x02) == 0x02) input1 = 1; else input1 = 0;
            if ((data[2] & 0x04) == 0x04) input2 = 1; else input2 = 0;
            if ((data[2] & 0x08) == 0x08) input3 = 1; else input3 = 0;
            if ((data[2] & 0x10) == 0x10) input4 = 1; else input4 = 0;
            if ((data[2] & 0x20) == 0x20) input5 = 1; else input5 = 0;
            if ((data[2] & 0x40) == 0x40) input6 = 1; else input6 = 0;


            byte Console_PIP_55Way = 1;
            byte Headliner_PIP_59Way = 1;
            byte Headliner_PIP_55Way = 1;
            byte Headliner_PIP_16Way_x1 = 1;
            byte Headliner_PIP_16Way_x2 = 1;
            byte Console_12VdcPO = 1;
            byte Console_5vUSB = 1;

            bool Console1 = input1.Equals(Console_PIP_55Way);
            bool Headliner1 = input1.Equals(Headliner_PIP_59Way);
            bool Headliner2 = input2.Equals(Headliner_PIP_55Way);
            bool Headliner3 = input3.Equals(Headliner_PIP_16Way_x1);
            bool Headliner4 = input4.Equals(Headliner_PIP_16Way_x2);
            bool Console5 = input5.Equals(Console_12VdcPO);
            bool Console6 = input6.Equals(Console_5vUSB);

            //******************************************************************
            //*************  Check for operator to connect the harness
            //*******************************************************************

            if ((Headliner1) && (Headliner3) && (Headliner4) || (Headliner2) && (Headliner3) && (Headliner4))

            {
                // ONE SHOT

                if (textBoxOperatorPrompts.Text.Contains("Cycle Complete"))
                {
                    // DO NOTHING
                    //textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected\n\r" + "\n\r" + "\n\r";
                }
                else
                {
                    textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Cycle Complete\n\r" + "\n\r" + "\n\r";

                    // **************************************************************************************************************************
                    // ****************** Start the Console Test CYCLE COMPLETE Sequence *************************************************************
                    // **************************************************************************************************************************
                    //***************************************************************************************************************************
                    //***************************************************************************************************************************

                    _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 1); // Deenergize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 1); // Denergize Sol #2   CONSOLE 55-way DRAW DOWN

                    // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
                    // AIOUSB.DIO_Write1(global_variables.diDIO, 9, 1);  // Denergize SOL #1   CONSOLE 55-way LATCH

                    //AIOUSB.DIO_Write1(global_variables.diDIO, 11, 0); // Energize Sol #3   HEADLINER DRAW DOWN BH #1 59-way
                    // AIOUSB.DIO_Write1(global_variables.diDIO, 9, 0);  // Turn ON SOL #1 HEADLINER LATCH BH#1 59-WAY

                    // Initialize all Outputs to the OFF State
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 6, 1);  // Deactivate TEST FAIL (Interlock)
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 7, 1);  // Deactivate TEST PASS (Interlock)
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 8, 1);  // Deactivate END OF CYCLE (Interlock)
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 9, 1);  // Turn OFF SOL #1   CONSOLE 55-way LATCH / HEADLINER LATCH BH#1
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 10, 1); // Turn OFF SOL #2   CONSOLE 55-way DRAW DOWN / HEADLINER LATCH BH#2
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 11, 1); // Turn OFF SOL #3   HEADLINER DRAW DOWN BH #1
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 12, 1); // Turn OFF SOL #4   HEADLINER DRAW DOWN BH #2
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 13, 1); // TURN OFF SOL #5   HEADLINER AIR EJECT BH #3
                    _ = AIOUSB.DIO_Write1(gv.diDIO, 14, 1); // CONSOLE (LED) RFID TEST BLOCK  5VdcUSB & 12Vdc Power Outlet
                }
            }

            //if (Console1) // Console_PIP_55Way has been detected

            if ((Headliner1) && (Headliner2) && (Headliner3) && (Headliner4))

            {
                //******************************************************************
                //*************  Check for operator to reconnect the 55-way harness
                //*******************************************************************

                //    AIOUSB.DIO_Write1(global_variables.diDIO, 11, 0); // Reenergize Sol #2   CONSOLE 59-way DRAW DOWN for bench validation at ETC
                //    AIOUSB.DIO_Write1(global_variables.diDIO, 10, 0); // Renergize Sol #2   CONSOLE 55-way DRAW DOWN

                // May require time delay or other way like analog channel reads to make sure the Drawdown and connector is fully seated before energizing the LATCH Solenoid ?
                //     AIOUSB.DIO_Write1(global_variables.diDIO, 9, 0);  // Renergize SOL #1   CONSOLE 55-way LATCH

                //AIOUSB.DIO_Write1(global_variables.diDIO, 11, 0); // Energize Sol #3   HEADLINER DRAW DOWN BH #1 59-way
                //AIOUSB.DIO_Write1(global_variables.diDIO, 9, 0);  // Turn ON SOL #1 HEADLINER LATCH BH#1 59-WAY

                ///  textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "55-Way PIP detected";
                //  textBoxOperatorPrompts.Text = textBoxOperatorPrompts.Text + "Cycle Start";

                //timer1.Stop();
                ////Form3 frm3 = new Form3();
                //global_variables.frm3.Show();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Stop();
            //Form4 frm4 = new Form4();
            gv.HeadlinerConnectTestForm.Show();
        }
    }
}